/*   DirectDraw ⏕NX  Ver 0.20   */
/*                                     */
/*                                     */
/*   by Atsushi             1999/9/7   */


#include "basic.h"

#include "DirectDrawAssistant.h"


/*   ---   RXgN^   ---   */

DirectDrawAssistant::DirectDrawAssistant(IDirectDrawSurface7* surface)
{
	this->surface=surface;
	
	init();
}


/*   ---      ---   */

void DirectDrawAssistant::init(void)
{
	DWORD mask;

	desc.dwSize=sizeof(DDSURFACEDESC2);
	desc.ddpfPixelFormat.dwSize=sizeof(DDPIXELFORMAT);
	surface->GetSurfaceDesc(&desc);
	
	mask=desc.ddpfPixelFormat.dwRBitMask;
	for (shiftR=0;!(mask & 1);shiftR++) mask>>=1;
	for (scaleR=8; (mask & 1);scaleR--) mask>>=1;
	
	mask=desc.ddpfPixelFormat.dwGBitMask;
	for (shiftG=0;!(mask & 1);shiftG++) mask>>=1;
	for (scaleG=8; (mask & 1);scaleG--) mask>>=1;
	
	mask=desc.ddpfPixelFormat.dwBBitMask;
	for (shiftB=0;!(mask & 1);shiftB++) mask>>=1;
	for (scaleB=8; (mask & 1);scaleB--) mask>>=1;
	
	tableR=new DWORD[256];
	tableG=new DWORD[256];
	tableB=new DWORD[256];
	for (int i=0;i<=255;i++)
	{
		tableR[i]=((i>>scaleR)<<shiftR);
		tableG[i]=((i>>scaleG)<<shiftG);
		tableB[i]=((i>>scaleB)<<shiftB);
	}
}


/*   ---   _   ---   */

// :Lock  Dubugger::println() ͎g܂
void DirectDrawAssistant::lock(void)
{
	surface->Lock(NULL,&desc,NULL,NULL);
}

// :Lock  Dubugger::println() ͎g܂
void DirectDrawAssistant::lock(DWORD flag)
{
	surface->Lock(NULL,&desc,flag,NULL);
}

void DirectDrawAssistant::unlock(void)
{
	surface->Unlock(NULL);
}

DWORD DirectDrawAssistant::getPixel(int x,int y)
{
	return *((DWORD*)((byte*)(desc.lpSurface)+
	                  x*desc.ddpfPixelFormat.dwRGBBitCount/8+
	                  y*desc.lPitch));
}

void DirectDrawAssistant::setPixel(int x,int y,DWORD rgb)
{
	*((DWORD*)((byte*)(desc.lpSurface)+
	    x*desc.ddpfPixelFormat.dwRGBBitCount/8+y*desc.lPitch))=
	    *((DWORD*)((byte*)(desc.lpSurface)+
	    x*desc.ddpfPixelFormat.dwRGBBitCount/8+y*desc.lPitch)) &
	    desc.ddpfPixelFormat.dwRGBAlphaBitMask | rgb;
}


/*   ---      ---   */

int DirectDrawAssistant::getWidth(void)
{
	return desc.dwWidth;
}

int DirectDrawAssistant::getHeight(void)
{
	return desc.dwHeight;
}


/*   ---   p   ---   */

DWORD* DirectDrawAssistant::getRedToPixel(void)
{
	return tableR;
}

DWORD* DirectDrawAssistant::getGreenToPixel(void)
{
	return tableG;
}

DWORD* DirectDrawAssistant::getBlueToPixel(void)
{
	return tableB;
}

int DirectDrawAssistant::getRedShift(void)
{
	return shiftR;
}

int DirectDrawAssistant::getGreenShift(void)
{
	return shiftG;
}

int DirectDrawAssistant::getBlueShift(void)
{
	return shiftB;
}

int DirectDrawAssistant::getRedScale(void)
{
	return scaleR;
}

int DirectDrawAssistant::getGreenScale(void)
{
	return scaleG;
}

int DirectDrawAssistant::getBlueScale(void)
{
	return scaleB;
}

DWORD DirectDrawAssistant::getRedMask(void)
{
	return desc.ddpfPixelFormat.dwRBitMask;
}

DWORD DirectDrawAssistant::getGreenMask(void)
{
	return desc.ddpfPixelFormat.dwGBitMask;
}

DWORD DirectDrawAssistant::getBlueMask(void)
{
	return desc.ddpfPixelFormat.dwBBitMask;
}


/*   ---   DirectX   ---   */

IDirectDrawSurface7* DirectDrawAssistant::getSurface(void)
{
	return surface;
}

DDSURFACEDESC2 DirectDrawAssistant::getSurfaceDesc(void)
{
	return desc;
}


/*   ---   fXgN^   ---   */

DirectDrawAssistant::~DirectDrawAssistant(void)
{
	delete[] tableR;
	delete[] tableG;
	delete[] tableB;
}
