/*   DirectX7 ǗNX  Ver 0.80   */
/*                                   */
/*                                   */
/*   by Atsushi         1999/11/22   */


class DirectXManager:public Object
{
private:
	HWND window;
	
	IDirectDraw7* ddraw;
	IDirectDrawSurface7* primary;
	IDirectDrawSurface7* backBuffer;
	IDirectDrawSurface7* zBuffer;
	IDirectDrawClipper* clipper;
	
	IDirect3D7* d3d;
	IDirect3DDevice7* device;
	
	boolean hal;
	boolean fullscreen;
	
	void initDDraw(int width,int height,int bpp,boolean fullscreen);
	void initD3D(int width,int height,boolean fullscreen);
	
	void releaseDDraw(void);
	void releaseD3D(void);

public:
	DirectXManager(HWND window);
	~DirectXManager(void);
	
	virtual void init2D(int width,int height,boolean fullscreen);
	virtual void init3D(int width,int height,boolean fullscreen);
	virtual void init2D(int width,int height,int bpp,boolean fullscreen);
	virtual void init3D(int width,int height,int bpp,boolean fullscreen);
	
	static HRESULT CALLBACK D3DEnumDevicesCallback(
	    LPSTR deviceDescription,LPSTR deviceName,
	    D3DDEVICEDESC7* desc,void* userData);
	static HRESULT CALLBACK D3DEnumPixelFormatsCallback(
	    DDPIXELFORMAT* pixelFormat,VOID* userData);
	
	virtual IDirectDraw7* getDirectDraw(void);
	virtual IDirectDrawSurface7* getPrimarySurface(void);
	virtual IDirectDrawSurface7* getBackBuffer(void);
	virtual IDirectDrawSurface7* createSurface(DDSURFACEDESC2* desc);
	virtual IDirectDrawPalette* createPalette(DWORD flags,PALETTEENTRY* entry);
	virtual IDirectDrawClipper* createClipper(void);
	
	virtual IDirect3D7* getDirect3D(void);
	virtual IDirect3DDevice7* get3DDevice(void);
	
	virtual void changeDisplayMode(int width,int height,boolean fullscreen);
	virtual boolean isFullscreen(void);
	virtual boolean isHAL(void);
	
	virtual void restore(void);
	
	virtual void release(void);
};
