/*   Alignment w摜`  Ver 0.00   */
/*                                      */
/*                                      */
/*   by Atsushi             1999/8/29   */


#include "basic.h"

#include "Stamp.h"


/*   ---   萔   ---   */

const double Stamp::ALIGN_LEFT  = 0.0;
const double Stamp::ALIGN_RIGHT =-1.0;
const double Stamp::ALIGN_CENTER=-0.5;
const double Stamp::ALIGN_TOP   = 0.0;
const double Stamp::ALIGN_BOTTOM=-1.0;


/*   ---   RXgN^   ---   */

Stamp::Stamp(IDirectDrawSurface7* image,boolean transparency)
{
	this->image       =image;
	this->transparency=transparency;
	
	init();
}

Stamp::Stamp(IDirectDrawSurface7* image)
{
	this->image       =image;
	this->transparency=FALSE;
	
	init();
}


/*   ---      ---   */

void Stamp::init(void)
{
	DDSURFACEDESC2 ddsd;

	ddsd.dwSize=sizeof(DDSURFACEDESC2);
	image->GetSurfaceDesc(&ddsd);
	width =ddsd.dwWidth;
	height=ddsd.dwHeight;
	
	alignX=ALIGN_LEFT;
	alignY=ALIGN_TOP;
}


/*   ---   傫   ---   */

int Stamp::getWidth(void)
{
	return width;
}

int Stamp::getHeight(void)
{
	return height;
}


/*   ---      ---   */

void Stamp::setAlignment(double alignX,double alignY)
{
	this->alignX=alignX;
	this->alignY=alignY;
}


/*   ---   `   ---   */

void Stamp::paint(IDirectDrawSurface7* target,int x,int y)
{
	RECT destRect,srcRect;

	destRect.left  =x+(int)(width *alignX);
	destRect.top   =y+(int)(height*alignY);
	destRect.right =x+(int)(width *alignX)+width ;
	destRect.bottom=y+(int)(height*alignY)+height;
	srcRect.left  =0;
	srcRect.top   =0;
	srcRect.right =width ;
	srcRect.bottom=height;
	
	srcRect.left  +=max(  0,destRect.left  )-destRect.left  ;
	srcRect.top   +=max(  0,destRect.top   )-destRect.top   ;
	srcRect.right +=min(640,destRect.right )-destRect.right ;
	srcRect.bottom+=min(480,destRect.bottom)-destRect.bottom;
	destRect.left  =max(  0,destRect.left  );
	destRect.top   =max(  0,destRect.top   );
	destRect.right =min(640,destRect.right );
	destRect.bottom=min(480,destRect.bottom);
	
	if (transparency)
	{
		target->Blt(&destRect,image,&srcRect,DDBLT_KEYSRC,NULL);
	}
	else
	{
		target->Blt(&destRect,image,&srcRect,NULL,NULL);
	}
}


/*   ---   fXgN^   ---   */

Stamp::~Stamp(void)
{
}
