/*   X File ǂݍ  Ver 0.60   */
/*                               */
/*                               */
/*   by Atsushi     1999/10/20   */


class TextureLoader;
class XFileObject;
class XFileObjectMesh;
class XFileObjectFrame;
template <class KeyType,class ValueType> class Hashtable;


class XFileLoader:public Object
{
private:
	IDirectDraw7* ddraw;
	IDirect3D7* d3d;
	IDirect3DDevice7* device;
	HINSTANCE hInstance;
	
	IDirectXFile* xFile;
	
	TextureLoader* textureLoader;
	Hashtable<String,IDirectDrawSurface7>* textureCache;
	String* path;
	
	void init(void);
	
	XFileObject* load(IDirectXFileEnumObject* enumObject);
	
	void parseFrame(IDirectXFileData* fileData,XFileObjectFrame* parent);
	void parseMesh(IDirectXFileData* fileData,XFileObjectFrame* parent);
	void parseMeshVertices(XFileObjectMesh* mesh,
	                       D3DVECTOR* verticesData,int vertexDataLength,
	                       VOID* faces,int faceLength);
	void parseMeshNormals(XFileObjectMesh* mesh,
	                      D3DVECTOR* normalData,int normalDataLength,
	                      VOID* faces,int faceLength);
	void parseMeshMaterialList(IDirectXFileData* fileData,
	                           XFileObjectMesh* mesh);
	void parseMeshMaterial(IDirectXFileData* fileData,XFileObjectMesh* mesh);

public:
	XFileLoader(IDirectDraw7* ddraw,IDirect3D7* d3d,
	            IDirect3DDevice7* device,HINSTANCE hInstance);
	~XFileLoader(void);
	
	virtual XFileObject* load(WORD resource);
	virtual XFileObject* load(String* filename);
	virtual XFileObject* load(char* filename);
};
