/*   X File ǂݍ  Ver 0.60   */
/*                               */
/*                               */
/*   by Atsushi     1999/10/20   */


class TransformMatrix;
class Vector3;
class XFileObjectNode;


class XFileObjectMesh:public XFileObjectNode
{
private:
	D3DVERTEX* vertices;
	WORD* indices;
	int vertexLength,indexLength;
	
	IDirectDrawSurface7* texture;
	D3DMATERIAL7 material;

public:
	XFileObjectMesh(String* name);
	~XFileObjectMesh(void);
	
	virtual void setVertices(D3DVERTEX* vertices,int vertexLength,
	                         WORD* indices,int indexLength);
	virtual void setTexture(IDirectDrawSurface7* texture);
	virtual void setTextureCoords(FLOAT* texCoords);
	virtual void setMaterial(D3DMATERIAL7 material);
	virtual void setNormals(D3DVECTOR* normals,int normalLength,
	                        WORD* indices,int indexLength);
	virtual void computeNormals(void);
	
	virtual void paint(IDirect3DDevice7* device);
	
	virtual D3DVERTEX* getVertices(void);
	virtual WORD* getIndices(void);
	virtual int getVertexLength(void);
	virtual int getIndexLength(void);
	virtual IDirectDrawSurface7* getTexture(void);
	virtual D3DMATERIAL7 getMaterial(void);
	virtual Vector3** getVertices(TransformMatrix* transform);
	virtual TransformMatrix* getTransformMatrix(String* name);
	
	virtual void computeBoundingSphereCenter(TransformMatrix* matrix,
	                                         D3DVECTOR* center,
	                                         int* pointLength);
	virtual void computeBoundingSphereRadius(TransformMatrix* matrix,
	                                         D3DVECTOR* center,
	                                         D3DVALUE* radius);
};
