/*   X File ǂݍ  Ver 0.60   */
/*                               */
/*                               */
/*   by Atsushi     1999/10/20   */


#include "basic.h"

#include "lib/math/Vector3.h"
#include "lib/math/Matrix4.h"
#include "lib/math/TransformMatrix.h"
#include "XFileObjectNode.h"


/*   ---   RXgN^   ---   */

XFileObjectNode::XFileObjectNode(String* name)
{
	this->name=name;
	
	next =NULL;
	child=NULL;
}


/*   ---   m[h   ---   */

void XFileObjectNode::addNext(XFileObjectNode* node)
{
	if (next!=NULL)
	{
		next->addNext(node);
	}
	else
	{
		next=node;
	}
}

void XFileObjectNode::addChild(XFileObjectNode* node)
{
	if (child!=NULL)
	{
		child->addNext(node);
	}
	else
	{
		child=node;
	}
}

XFileObjectNode* XFileObjectNode::getNext(void)
{
	return next;
}

XFileObjectNode* XFileObjectNode::getNode(String* name)
{
	XFileObjectNode* node;

	if (this->name->equals(name))
	{
		return this;
	}
	else
	{
		if (child!=NULL)
		{
			node=child->getNode(name);
			
			if (node!=NULL) return node;
		}
		if (next!=NULL)
		{
			node=next->getNode(name);
			
			if (node!=NULL) return node;
		}
	}
	
	return NULL;
}

void XFileObjectNode::detachNode(String* name)
{
	XFileObjectNode* node;

	if (child!=NULL)
	{
		if (child->name->equals(name))
		{
			node=child;
			child=child->next;
			node->next=NULL;
			
			delete node;
		}
		else
		{
			child->detachNode(name);
		}
	}
	if (next!=NULL)
	{
		if (next->name->equals(name))
		{
			node=next;
			next=next->next;
			node->next=NULL;
			
			delete node;
		}
		else
		{
			next->detachNode(name);
		}
	}
}


/*   ---   O   ---   */

String* XFileObjectNode::getName(void)
{
	return name;
}


/*   ---   Ë   ---   */

void XFileObjectNode::computeBoundingSphereCenter(
    TransformMatrix* matrix,D3DVECTOR* center,int* pointLength)
{
	if (child!=NULL)
	{
		child->computeBoundingSphereCenter(matrix,center,pointLength);
	}
	if (next!=NULL)
	{
		next->computeBoundingSphereCenter(matrix,center,pointLength);
	}
}

void XFileObjectNode::computeBoundingSphereRadius(
    TransformMatrix* matrix,D3DVECTOR* center,D3DVALUE* radius)
{
	if (child!=NULL)
	{
		child->computeBoundingSphereRadius(matrix,center,radius);
	}
	if (next!=NULL)
	{
		next->computeBoundingSphereRadius(matrix,center,radius);
	}
}


/*   ---   fXgN^   ---   */

XFileObjectNode::~XFileObjectNode(void)
{
	if (child!=NULL) delete child;
	if (next !=NULL) delete next;
	
	delete name;
}
