/*   DialogBox NX  Ver 0.00   */
/*                                */
/*                                */
/*   by Atsushi       1999/5/11   */


#include "basic.h"

#include "lib/util/Enumeration.h"
#include "lib/event/EventListener.h"
#include "lib/event/EventListenerEnumeration.h"
#include "lib/event/EventListenerContainer.h"
#include "lib/event/DialogListener.h"
#include "GUI.h"
#include "Dialog.h"


/*   ---   ÓIoϐ   ---   */

Dialog* Dialog::first=NULL;
Dialog* Dialog::active=NULL;


/*   ---   RXgN^   ---   */

Dialog::Dialog(void)
{
	next=first;
	first=this;
	
	listeners=new EventListenerContainer<DialogListener>();
}


/*   ---   \   ---   */

boolean Dialog::isShowing()
{
	return (handle!=NULL);
}


/*   ---      ---   */

String* Dialog::getItemText(int id)
{
	char* string;

	string=new char[300];
	GetDlgItemText(handle,id,string,300);
	
	return new String(string,TRUE);
}

void Dialog::setItemText(int id,String* text)
{
	SetDlgItemText(handle,id,text->toCharArray());
}

void Dialog::addStringToComboBox(int id,String* text)
{
	SendDlgItemMessage(handle,id,CB_ADDSTRING,0,
	            ((LPARAM)(LPCTSTR)(text->toCharArray())));
}


/*   ---   Cxg   ---   */

BOOL CALLBACK Dialog::DialogProc(HWND dialog,UINT message,
                                 WPARAM wParam,LPARAM lParam)
{
	Dialog* target;
	boolean done;

	for (target=first;target->handle!=dialog;target=target->next)
	{
		if (target==active)
		{
			target->handle=dialog;
			break;
		}
		if (target->next==NULL)
		{
			return (message==WM_INITDIALOG);
		}
	}
	
	done =target->fireDialogMessageSent(dialog,message,wParam,lParam);
	done|=target->DialogProc(message,wParam,lParam);
	
	return done;
}

void Dialog::addDialogListener(DialogListener* listener)
{
	listeners->addEventListener(listener);
}

void Dialog::removeDialogListener(DialogListener* listener)
{
	listeners->removeEventListener(listener);
}

boolean Dialog::fireDialogMessageSent(HWND dialog,UINT message,
                                      WPARAM wParam,LPARAM lParam)
{
	boolean done;

	done=FALSE;
	for (EventListenerEnumeration<DialogListener>*
	     enume=listeners->getEventListeners();
	     enume->hasMoreElements();)
	{
		done|=enume->nextElement()
		           ->dialogMessageSent(dialog,message,wParam,lParam);
	}
	
	return done;
}


/*   ---   fXgN^   ---   */

Dialog::~Dialog(void)
{
	Dialog* back;

	if (first==this)
	{
		first=next;
	}
	else
	{
		for (back=first;back->next!=this;back=back->next);
		back->next=next;
	}
}
