/*   Window NX  Ver 0.20   */
/*                             */
/*                             */
/*   by Atsushi    1999/5/11   */


#include "basic.h"

#include "lib/util/Enumeration.h"
#include "lib/event/EventListener.h"
#include "lib/event/EventListenerEnumeration.h"
#include "lib/event/EventListenerContainer.h"
#include "lib/event/WindowListener.h"
#include "GUI.h"
#include "Window.h"


/*   ---   ÓIoϐ   ---   */

Window* Window::first=NULL;
Window* Window::active=NULL;


/*   ---   RXgN^   ---   */

Window::Window(void)
{
	next=first;
	first=this;
	
	listeners=new EventListenerContainer<WindowListener>();
}


/*   ---      ---   */

LRESULT CALLBACK Window::WindowProc(HWND window,UINT message,
                                    WPARAM wParam,LPARAM lParam)
{
	Window* target;

	for (target=first;target!=NULL;target=target->next)
	{
		target->fireWindowMessageSent(window,message,wParam,lParam);
	}
	
	for (target=first;target->handle!=window;target=target->next)
	{
		if (target==active)
		{
			target->handle=window;
			break;
		}
		if (target->next==NULL)
		{
			return DefWindowProc(window,message,wParam,lParam);
		}
	}
	
	return target->WindowProc(message,wParam,lParam);
}

void Window::addWindowListener(WindowListener* listener)
{
	listeners->addEventListener(listener);
}

void Window::removeWindowListener(WindowListener* listener)
{
	listeners->removeEventListener(listener);
}

void Window::fireWindowMessageSent(HWND window,UINT message,
                                   WPARAM wParam,LPARAM lParam)
{
	for (EventListenerEnumeration<WindowListener>*
	     enume=listeners->getEventListeners();
	     enume->hasMoreElements();)
	{
		enume->nextElement()->windowMessageSent(window,message,wParam,lParam);
	}
}


/*   ---   fXgN^   ---   */

Window::~Window(void)
{
	Window* back;

	delete listeners;
	
	if (first==this)
	{
		first=next;
	}
	else
	{
		for (back=first;back->next!=this;back=back->next);
		back->next=next;
	}
}
