/*   FileInputStream NX  Ver 0.00   */
/*                                      */
/*                                      */
/*   by toyo    1999/6/6                */

#include "basic.h"
#include "IOException.h"
#include "FileNotFoundException.h"
#include "InputStream.h"
#include "FileInputStream.h"

FileInputStream::FileInputStream(char *name) throw (IOException*){
	initInstance(name);
}

FileInputStream::FileInputStream(String *name) throw (IOException*){	
	initInstance(name->toCharArray());
}

FileInputStream::~FileInputStream(){
}

void FileInputStream::initInstance(char *name) throw (IOException*){
	HANDLE hFile;
	
	hFile=CreateFile(
		name,
		GENERIC_READ,
		0,
		NULL,
		OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL,
		NULL
	);
	
	if(hFile==INVALID_HANDLE_VALUE){
		DWORD errorCode=GetLastError();
		if(errorCode==2){
			throw new FileNotFoundException(getErrorMessage());
		}else{
			throw new IOException(getErrorMessage());
		}
	}else{
		this->fileHandle=hFile;
		this->readSize=0;
		this->fileSize=GetFileSize(fileHandle,NULL);
	}
}

String *FileInputStream::getErrorMessage(){
	char *errorMessage=new char[64];
	
	for(int i=0;i<64;i++)errorMessage[i]=NULL;

	FormatMessage(
		FORMAT_MESSAGE_FROM_SYSTEM | 
		FORMAT_MESSAGE_IGNORE_INSERTS,
		NULL,
		GetLastError(),
		MAKELANGID(LANG_NEUTRAL,SUBLANG_DEFAULT),
		errorMessage,
		64,
		NULL
	);
	
	return new String(errorMessage);
}

int FileInputStream::available() throw (IOException*){
	return fileSize-readSize;
}

void FileInputStream::close() throw (IOException*){
	CloseHandle(fileHandle);
}

int FileInputStream::read() throw (IOException*){
	DWORD dwNumberOfBytes;
	boolean returnValue;
	char *buffer=new char[1];

	returnValue=ReadFile(fileHandle,buffer,1,&dwNumberOfBytes,NULL);
	if(!returnValue){
		throw new IOException(getErrorMessage());
	}else if(dwNumberOfBytes==0){
		return -1;
	}else{
		readSize++;
		return buffer[0];
	}
}

int FileInputStream::read(BYTE buffer[],int offset,int length) throw (IOException*){
	DWORD dwNumberOfBytesRead;
	boolean returnValue;
	returnValue=ReadFile(fileHandle,buffer+offset,length,&dwNumberOfBytesRead,NULL);
	if(!returnValue){
		throw new IOException(getErrorMessage());
	}else{
		readSize+=dwNumberOfBytesRead;
		return (int)dwNumberOfBytesRead;
	}
}
