/*   FileOutputStream NX  Ver 0.00   */
/*                                       */
/*                                       */
/*   by toyo    1999/5/30                */

#include "basic.h"
#include "IOException.h"
#include "OutputStream.h"
#include "FileOutputStream.h"

FileOutputStream::FileOutputStream(String *name) throw (IOException*){
	initInstance(name->toCharArray());
}

FileOutputStream::FileOutputStream(char* name) throw (IOException*){
	initInstance(name);
}

FileOutputStream::~FileOutputStream(void){
}

void FileOutputStream::initInstance(char *name){
	HANDLE hFile;
	
	hFile=CreateFile(
		name,
		GENERIC_WRITE,
		0,
		NULL,
		CREATE_ALWAYS,
		FILE_ATTRIBUTE_NORMAL,
		NULL
	);
	
	if(hFile==INVALID_HANDLE_VALUE){
		throw new IOException(getErrorMessage());
	}else{
		this->fileHandle=hFile;
	}
}

void FileOutputStream::close() throw (IOException*){
	CloseHandle(fileHandle);
}

void FileOutputStream::write(BYTE b) throw (IOException*){
	DWORD dwNumberOfBytesWritten;
	boolean returnValue=WriteFile(fileHandle,&b,1,&dwNumberOfBytesWritten,NULL);
	if(!returnValue){
		throw new IOException(getErrorMessage());
	}
}

void FileOutputStream::write(BYTE buffer[],int off,int len) throw (IOException*){
	DWORD dwNumberOfBytesWritten;
	boolean returnValue=WriteFile(fileHandle,buffer+off,len,&dwNumberOfBytesWritten,NULL);
	if(!returnValue){
		throw new IOException(getErrorMessage());
	}
}

String *FileOutputStream::getErrorMessage(){
	char *errorMessage=new char[64];
	
	for(int i=0;i<64;i++)errorMessage[i]=NULL;

	FormatMessage(
		FORMAT_MESSAGE_FROM_SYSTEM | 
		FORMAT_MESSAGE_IGNORE_INSERTS,
		NULL,
		GetLastError(),
		MAKELANGID(LANG_NEUTRAL,SUBLANG_DEFAULT),
		errorMessage,
		64,
		NULL
	);
	
	return new String(errorMessage);
}
