/*	 Serialization	Ver 0.10	 */
/*					             */
/*							     */
/*	 by toyo		 1999/7/13	 */

#include "basic.h"
#include "IOException.h"
#include "InputStream.h"
#include "ObjectInputStream.h"

const int ObjectInputStream::BUFFER_SIZE=256;

/*	 ---	 RXgN^		---		*/

ObjectInputStream::ObjectInputStream(void){
}

ObjectInputStream::ObjectInputStream(InputStream* in)
throw (IOException*)
{
	this->in=in;
	init();
}


/*	 ---	 		---		*/

void ObjectInputStream::init(void)
throw (IOException*)
{
	//bufferSize=4096*8;
	//bufferSize=2*1024*1024;
	bufferSize=BUFFER_SIZE;
	bufferOffset=0;
	bufferReadSize=0;
	buffer=new byte[bufferSize];
	isFirstCall=true;
}


/*	 ---	 ǂݍ		---		*/


boolean ObjectInputStream::readBoolean(void)
throw (IOException*)
{
	byte b;
	memmove(&b,buffer+bufferOffset,1);
	bufferOffset++;
	return (boolean)b;
}

byte ObjectInputStream::readByte(void)
throw (IOException*)
{
	byte b;
	memmove(&b,buffer+bufferOffset,1);
	bufferOffset++;
	return b;
}

int ObjectInputStream::readInteger(void)
throw (IOException*)
{
	int intValue;
	memmove(&intValue,buffer+bufferOffset,4);
	bufferOffset+=4;
	return intValue;
}

float ObjectInputStream::readFloat(void)
throw (IOException*)
{
	float floatValue;
	memmove(&floatValue,buffer+bufferOffset,4);
	bufferOffset+=4;
	return floatValue;
}

double ObjectInputStream::readDouble(void)
throw (IOException*)
{
	double doubleValue;
	memmove(&doubleValue,buffer+bufferOffset,8);
	bufferOffset+=8;
	return doubleValue;
}

String* ObjectInputStream::readString(void)
throw (IOException*)
{
	int length;
	memmove(&length,buffer+bufferOffset,4);
	bufferOffset+=4;

	if(length==-1){
		return NULL;
	}else if(length==0){
		return new String("");
	}else{
		char *charArray=new char[length+1];
		memmove(charArray,buffer+bufferOffset,length);
		charArray[length]=NULL;
		bufferOffset+=length;
		return new String(charArray);
	}
}

//obt@TCYύX

void ObjectInputStream::changeBufferSize(int newBufferSize){
	byte *buffer=new byte[newBufferSize];
	
	if(bufferOffset!=0){
		if(bufferOffset<=newBufferSize){
			memmove(buffer,this->buffer,bufferOffset);
		}else{
			memmove(buffer,this->buffer,newBufferSize);
		}
	}
	
	if(this->buffer!=NULL)delete[] this->buffer;
	this->bufferSize=newBufferSize;
	this->buffer=buffer;
}


/*	 ---	 fXgN^		---		*/

ObjectInputStream::~ObjectInputStream(void)
{}


int ObjectInputStream::available() throw (IOException*){
	return in->available();
}

void ObjectInputStream::close() throw (IOException*){
	in->close();
}

void ObjectInputStream::mark(int m){
	in->mark(m);
}

boolean ObjectInputStream::markSupported(){
	return in->markSupported();
}

int ObjectInputStream::read() throw (IOException*){
	return in->read();
}

int ObjectInputStream::read(BYTE b[],int off,int len) throw (IOException*){
	return in->read(b,off,len);
}

void ObjectInputStream::reset() throw (IOException*){
	in->reset();
}

long ObjectInputStream::skip(long l) throw (IOException*){
	return in->skip(l);
}
