/*   Serialization  Ver 0.10   */
/*                             */
/*                             */
/*   by toyo     1999/7/13      */

class IOException;
class InputStream;

class ObjectInputStream:public InputStream
{
private:
	void init(void);
public:
	static const int BUFFER_SIZE;

	BYTE *buffer;
	int bufferSize;
	int bufferOffset;
	int bufferReadSize;
	
	boolean isFirstCall;

	int currentObjectType;
	int currentObjectSize;
	
	InputStream* in;
	
	ObjectInputStream(void);
	ObjectInputStream(InputStream* in) throw (IOException*);
	~ObjectInputStream(void);
	
	virtual boolean readBoolean(void) throw (IOException*);
	virtual int readInteger(void) throw (IOException*);
	virtual float readFloat(void) throw (IOException*);
	virtual double readDouble(void) throw (IOException*);
	virtual String* readString(void) throw (IOException*);
	virtual byte readByte(void) throw (IOException*);
	
	virtual void changeBufferSize(int newBufferSize);

	virtual int available() throw (IOException*);
	virtual void close() throw (IOException*);
	virtual void mark(int);
	virtual boolean markSupported();
	virtual int read() throw (IOException*);
	virtual int read(BYTE[],int,int) throw (IOException*);
	virtual void reset() throw (IOException*);
	virtual long skip(long) throw (IOException*);
};

//O[o֐
//readObject

template <class Type>
Type* readObject(ObjectInputStream *oin) throw (IOException*){
	int returnValue=0;
	
	if(oin->isFirstCall){
		if(oin->bufferReadSize<8){//^ATCY
			returnValue=oin->in->read((BYTE *)oin->buffer,oin->bufferReadSize,8-oin->bufferReadSize);
			oin->bufferReadSize+=returnValue;
			
			/*
			int c;
			while((c=oin->read())!=-1){
				oin->buffer[oin->bufferReadSize++]=(BYTE)c;
				if(oin->bufferReadSize>=8)break;
			}
			*/
			
			if(oin->bufferReadSize<8){
				return NULL;
			}else{
				oin->bufferOffset=0;
				oin->currentObjectType=oin->readInteger();
				oin->currentObjectSize=oin->readInteger();

				if(oin->currentObjectSize+8>oin->bufferSize){
					oin->changeBufferSize(oin->currentObjectSize+8+256);
				}else if(oin->bufferSize!=ObjectInputStream::BUFFER_SIZE){
					if(oin->currentObjectSize+8<ObjectInputStream::BUFFER_SIZE){
						oin->changeBufferSize(ObjectInputStream::BUFFER_SIZE);
					}
				}
			}
		}
		
		returnValue=oin->in->read((BYTE *)oin->buffer,oin->bufferReadSize,oin->currentObjectSize+8-oin->bufferReadSize);
		oin->bufferReadSize+=returnValue;
		
		/*
		int c;
		while((c=oin->read())!=-1){
			oin->buffer[oin->bufferReadSize++]=(BYTE)c;
			if(oin->bufferReadSize>=oin->currentObjectSize+8)break;
		}
		*/
		
		if(oin->bufferReadSize>=oin->currentObjectSize+8){
			Type *type=Type::newInstance(oin->currentObjectType);
			
			oin->isFirstCall=false;
			
			type->readObject(oin);
			
			oin->bufferOffset=0;
			oin->bufferReadSize=0;
			oin->isFirstCall=true;
			
//			Debugger::println("readObject type:");
//			Debugger::println(oin->currentObjectType);
			
//			Debugger::println("readObject size:");
//			Debugger::println(oin->currentObjectSize);
			
			return type;
		}else{
			return NULL;
		}
	}else{
		int typeID=oin->readInteger();
		
		if(typeID==-1){
			return NULL;
		}

		Type *type=Type::newInstance(typeID);
		type->readObject(oin);
		return type;
	}
}


//#include "ObjectInputStream.cpp"
