/*	 Serialization	Ver 0.10	 */
/*								 */
/*							     */
/*	 by toyo		 1999/7/13   */

#include "basic.h"
#include "IOException.h"
#include "OutputStream.h"
#include "ObjectOutputStream.h"

const int ObjectOutputStream::BUFFER_SIZE=4096;

/*	 ---	 RXgN^		---		*/

ObjectOutputStream::ObjectOutputStream(void){
}

ObjectOutputStream::ObjectOutputStream(OutputStream* out)
throw (IOException*)
{
	this->out=out;
	this->isFirstCall=true;
	init();
}


/*	 ---	 		---		*/

void ObjectOutputStream::init(void)
throw (IOException*)
{
//	bufferSize=4096*8;
//	bufferSize=2*1024*1024;
	bufferSize=BUFFER_SIZE;
	buffer=new byte[bufferSize];
}



/*	 ---	 		---		*/
void ObjectOutputStream::writeBoolean(boolean value)
throw (IOException*)
{
	if(bufferOffset+1>bufferSize){
		changeBufferSize(bufferSize+BUFFER_SIZE);
	}
	
	memmove(buffer+bufferOffset,&value,1);
	bufferOffset++;
}

void ObjectOutputStream::writeByte(byte b) throw (IOException *){
	if(bufferOffset+1>bufferSize){
		changeBufferSize(bufferSize+BUFFER_SIZE);
	}

	memmove(buffer+bufferOffset,&b,1);
	bufferOffset++;
}

void ObjectOutputStream::writeInteger(int value)
throw (IOException*)
{
	if(bufferOffset+4>bufferSize){
		changeBufferSize(bufferSize+BUFFER_SIZE);
	}

	memmove(buffer+bufferOffset,&value,4);
	bufferOffset+=4;
}

void ObjectOutputStream::writeFloat(float value)
throw (IOException*)
{
	if(bufferOffset+4>bufferSize){
		changeBufferSize(bufferSize+BUFFER_SIZE);
	}

	memmove(buffer+bufferOffset,&value,4);
	bufferOffset+=4;
}

void ObjectOutputStream::writeDouble(double value)
throw (IOException*)
{
	if(bufferOffset+8>bufferSize){
		changeBufferSize(bufferSize+BUFFER_SIZE);
	}

	memmove(buffer+bufferOffset,&value,8);
	bufferOffset+=8;
}

void ObjectOutputStream::writeString(String* value)
throw (IOException*)
{
	if(value==NULL){
		if(bufferOffset+4>bufferSize){
			changeBufferSize(bufferSize+BUFFER_SIZE);
		}
		
		int length=-1;
		memmove(buffer+bufferOffset,&length,4);
		bufferOffset+=4;
	}else{
		int length=value->length();
		
		if(bufferOffset+4+length>bufferSize){
			changeBufferSize(bufferSize+BUFFER_SIZE);
		}
		
		memmove(buffer+bufferOffset,&length,4);
		bufferOffset+=4;
		memmove(buffer+bufferOffset,value->toCharArray(),length);
		bufferOffset+=length;
	}
}

OutputStream* ObjectOutputStream::getOutputStream()
{
	return out;
}


//obt@TCYύX

void ObjectOutputStream::changeBufferSize(int newBufferSize){
	byte *buffer=new byte[newBufferSize];
	
	if(bufferOffset!=0){
		if(bufferOffset<=newBufferSize){
			memmove(buffer,this->buffer,bufferOffset);
		}else{
			memmove(buffer,this->buffer,newBufferSize);
		}
	}
	
	if(this->buffer!=NULL)delete[] this->buffer;
	this->bufferSize=newBufferSize;
	this->buffer=buffer;
}


/*	 ---	 fXgN^		---		*/

ObjectOutputStream::~ObjectOutputStream(void)
{
}

void ObjectOutputStream::close() throw (IOException*){
	out->close();
}

void ObjectOutputStream::flush() throw (IOException*){
	out->flush();
}

void ObjectOutputStream::write(BYTE b) throw (IOException*){
	out->write(b);
}

void ObjectOutputStream::write(BYTE b[], int off, int len) throw (IOException*){
	out->write(b,off,len);
}
