/*   Serialization  Ver 0.10   */
/*                             */
/*                             */
/*   by toyo     1999/7/13      */

class IOException;
class OutputStream;

class ObjectOutputStream:public OutputStream
{
private:
	void init(void);
public:
	static const int BUFFER_SIZE;

	BYTE *buffer;
	int bufferSize;
	int bufferOffset;
	
	boolean isFirstCall;
	
	OutputStream* out;
	
	ObjectOutputStream(void);
	ObjectOutputStream(OutputStream* out) throw (IOException*);
	~ObjectOutputStream(void);
	
	virtual void writeBoolean(boolean value) throw (IOException*);
	virtual void writeInteger(int value) throw (IOException*);
	virtual void writeFloat(float value) throw (IOException*);
	virtual void writeDouble(double value) throw (IOException*);
	virtual void writeString(String* value) throw (IOException*);
	virtual void writeByte(byte b) throw (IOException *);

	virtual OutputStream* getOutputStream(void);
	
	virtual void changeBufferSize(int newBufferSize);

	virtual void close() throw (IOException*);
    virtual void flush() throw (IOException*);
    virtual void write(BYTE) throw (IOException*);
    virtual void write(BYTE[], int, int) throw (IOException*);
};

//O[o֐
//writeObject

template <class Type>
void writeObject(ObjectOutputStream *oout,Type* type)
throw (IOException*)
{
	if(oout->isFirstCall){
		oout->bufferOffset=8;
		
		oout->isFirstCall=false;
		type->writeObject(oout);
		oout->isFirstCall=true;
		
//		Debugger::println("ObjectOutputStream type:");
//		Debugger::println(type->getTypeID());
//		Debugger::println("ObjectOutputStream size:");
//		Debugger::println(oout->bufferOffset);
		
		int endBufferOffset=oout->bufferOffset;
     	
     	// object= type(4 byte) + size(4 byte) + contents (objectSize byte);
		int objectSize=endBufferOffset-8;
		
		oout->bufferOffset=0;

		oout->writeInteger(type->getTypeID());	//type
		oout->writeInteger(objectSize);			//size
		
		int length=objectSize+8;
		oout->out->write((BYTE*)oout->buffer,0,length);
		oout->out->flush();
		
		if(oout->bufferSize>ObjectOutputStream::BUFFER_SIZE){
			oout->changeBufferSize(ObjectOutputStream::BUFFER_SIZE);
		}
		
		/*
		int realType;
		memmove(&realType,oout->buffer,4);
		Debugger::println("real type:");
		Debugger::println(realType);
		
		int realSize;
		memmove(&realSize,oout->buffer+4,4);
		Debugger::println("real size:");
		Debugger::println(realSize);
		*/
		
//		Debugger::println("writeObject complete\n");
	}else{
		if(type==NULL){
			oout->writeInteger(-1);
		}else{
			oout->writeInteger(type->getTypeID());
			type->writeObject(oout);
		}
	}
}


//#include "ObjectOutputStream.cpp"