/*   fobOpNX  Ver 0.20   */
/*                                */
/*                                */
/*   by Atsushi       1999/4/26   */


#include "basic.h"

#include <stdio.h>


/*   ---      ---   */

clock_t _time;
boolean _time_flag;


/*   ---   RXgN^   ---   */

Debugger::Debugger()
{
}


/*   ---   \   ---   */

void Debugger::println(boolean value)
{
	if (value)
	{
		OutputDebugString("true\n");
	}
	else
	{
		OutputDebugString("false\n");
	}
}

void Debugger::println(short value)
{
	char error[256];

	sprintf(error,"%d\n",value);
	OutputDebugString(error);
}

void Debugger::println(int value)
{
	char error[256];

	sprintf(error,"%d\n",value);
	OutputDebugString(error);
}

void Debugger::println(long value)
{
	char error[256];

	sprintf(error,"%d\n",value);
	OutputDebugString(error);
}

void Debugger::println(float value)
{
	char error[256];

	sprintf(error,"%f\n",value);
	OutputDebugString(error);
}

void Debugger::println(double value)
{
	char error[256];

	sprintf(error,"%f\n",value);
	OutputDebugString(error);
}

void Debugger::println(char* value)
{
	OutputDebugString(value);
	OutputDebugString("\n");
}

void Debugger::println(unsigned short value)
{
	char error[256];

	sprintf(error,"%u\n",value);
	OutputDebugString(error);
}

void Debugger::println(unsigned int value)
{
	char error[256];

	sprintf(error,"%u\n",value);
	OutputDebugString(error);
}

void Debugger::println(unsigned long value)
{
	char error[256];

	sprintf(error,"%u\n",value);
	OutputDebugString(error);
}

void Debugger::println(void* value)
{
	char error[256];

	sprintf(error,"%p\n",value);
	OutputDebugString(error);
}

void Debugger::println(Exception* value)
{
	OutputDebugString((char*)(typeid(*value).name())+6);
	OutputDebugString("\n");
}

void Debugger::println(String* value)
{
	if (value==NULL)
	{
		OutputDebugString("null\n");
	}
	else
	{
		OutputDebugString(value->toCharArray());
		OutputDebugString("\n");
	}
}

void Debugger::println(Object* value)
{
	char error[256];

	if (value==NULL)
	{
		OutputDebugString("null\n");
	}
	else
	{
		sprintf(error,"%d\n",value);
		OutputDebugString(error);
	}
}


/*   ---   G[ʒu\   ---   */

void Debugger::printLine(char* file,int line)
{
	char error[256];

	sprintf(error,"%s(%d):",file,line);
	OutputDebugString(error);
}


/*   ---   oߎ\   ---   */

void Debugger::printTime(void)
{
	char error[256];

	sprintf(error,"%d\n",clock());
	OutputDebugString(error);
}


/*   ---   G[\   ---   */

void Debugger::printErrorDDraw(HRESULT value)
{
	switch (value)
	{
	case DD_OK:
		OutputDebugString("DD_OK\n");
		break;
	case DDERR_ALREADYINITIALIZED:
		OutputDebugString("DDERR_ALREADYINITIALIZED\n");
		break;
	case DDERR_BLTFASTCANTCLIP:
		OutputDebugString("DDERR_BLTFASTCANTCLIP\n");
		break;
	case DDERR_CANNOTATTACHSURFACE:
		OutputDebugString("DDERR_CANNOTATTACHSURFACE\n");
		break;
	case DDERR_CANNOTDETACHSURFACE:
		OutputDebugString("DDERR_CANNOTDETACHSURFACE\n");
		break;
	case DDERR_CANTCREATEDC:
		OutputDebugString("DDERR_CANTCREATEDC\n");
		break;
	case DDERR_CANTDUPLICATE:
		OutputDebugString("DDERR_CANTDUPLICATE\n");
		break;
	case DDERR_CANTLOCKSURFACE:
		OutputDebugString("DDERR_CANTLOCKSURFACE\n");
		break;
	case DDERR_CANTPAGELOCK:
		OutputDebugString("DDERR_CANTPAGELOCK\n");
		break;
	case DDERR_CANTPAGEUNLOCK:
		OutputDebugString("DDERR_CANTPAGEUNLOCK\n");
		break;
	case DDERR_CLIPPERISUSINGHWND:
		OutputDebugString("DDERR_CLIPPERISUSINGHWND\n");
		break;
	case DDERR_COLORKEYNOTSET:
		OutputDebugString("DDERR_COLORKEYNOTSET\n");
		break;
	case DDERR_CURRENTLYNOTAVAIL:
		OutputDebugString("DDERR_CURRENTLYNOTAVAIL\n");
		break;
	case DDERR_DDSCAPSCOMPLEXREQUIRED:
		OutputDebugString("DDERR_DDSCAPSCOMPLEXREQUIRED\n");
		break;
	case DDERR_DCALREADYCREATED:
		OutputDebugString("DDERR_DCALREADYCREATED\n");
		break;
	case DDERR_DEVICEDOESNTOWNSURFACE:
		OutputDebugString("DDERR_DEVICEDOESNTOWNSURFACE\n");
		break;
	case DDERR_DIRECTDRAWALREADYCREATED:
		OutputDebugString("DDERR_DIRECTDRAWALREADYCREATED\n");
		break;
	case DDERR_EXCEPTION:
		OutputDebugString("DDERR_EXCEPTION\n");
		break;
	case DDERR_EXCLUSIVEMODEALREADYSET:
		OutputDebugString("DDERR_EXCLUSIVEMODEALREADYSET\n");
		break;
	case DDERR_EXPIRED:
		OutputDebugString("DDERR_EXPIRED\n");
		break;
	case DDERR_GENERIC:
		OutputDebugString("DDERR_GENERIC\n");
		break;
	case DDERR_HEIGHTALIGN:
		OutputDebugString("DDERR_HEIGHTALIGN\n");
		break;
	case DDERR_HWNDALREADYSET:
		OutputDebugString("DDERR_HWNDALREADYSET\n");
		break;
	case DDERR_HWNDSUBCLASSED:
		OutputDebugString("DDERR_HWNDSUBCLASSED\n");
		break;
	case DDERR_IMPLICITLYCREATED:
		OutputDebugString("DDERR_IMPLICITLYCREATED\n");
		break;
	case DDERR_INCOMPATIBLEPRIMARY:
		OutputDebugString("DDERR_INCOMPATIBLEPRIMARY\n");
		break;
	case DDERR_INVALIDCAPS:
		OutputDebugString("DDERR_INVALIDCAPS\n");
		break;
	case DDERR_INVALIDCLIPLIST:
		OutputDebugString("DDERR_INVALIDCLIPLIST\n");
		break;
	case DDERR_INVALIDDIRECTDRAWGUID:
		OutputDebugString("DDERR_INVALIDDIRECTDRAWGUID\n");
		break;
	case DDERR_INVALIDMODE:
		OutputDebugString("DDERR_INVALIDMODE\n");
		break;
	case DDERR_INVALIDOBJECT:
		OutputDebugString("DDERR_INVALIDOBJECT\n");
		break;
	case DDERR_INVALIDPARAMS:
		OutputDebugString("DDERR_INVALIDPARAMS\n");
		break;
	case DDERR_INVALIDPIXELFORMAT:
		OutputDebugString("DDERR_INVALIDPIXELFORMAT\n");
		break;
	case DDERR_INVALIDPOSITION:
		OutputDebugString("DDERR_INVALIDPOSITION\n");
		break;
	case DDERR_INVALIDRECT:
		OutputDebugString("DDERR_INVALIDRECT\n");
		break;
	case DDERR_INVALIDSTREAM:
		OutputDebugString("DDERR_INVALIDSTREAM\n");
		break;
	case DDERR_INVALIDSURFACETYPE:
		OutputDebugString("DDERR_INVALIDSURFACETYPE\n");
		break;
	case DDERR_LOCKEDSURFACES:
		OutputDebugString("DDERR_LOCKEDSURFACES\n");
		break;
	case DDERR_MOREDATA:
		OutputDebugString("DDERR_MOREDATA\n");
		break;
	case DDERR_NEWMODE:
		OutputDebugString("DDERR_NEWMODE\n");
		break;
	case DDERR_NO3D:
		OutputDebugString("DDERR_NO3D\n");
		break;
	case DDERR_NOALPHAHW:
		OutputDebugString("DDERR_NOALPHAHW\n");
		break;
	case DDERR_NOBLTHW:
		OutputDebugString("DDERR_NOBLTHW\n");
		break;
	case DDERR_NOCLIPLIST:
		OutputDebugString("DDERR_NOCLIPLIST\n");
		break;
	case DDERR_NOCLIPPERATTACHED:
		OutputDebugString("DDERR_NOCLIPPERATTACHED\n");
		break;
	case DDERR_NOCOLORCONVHW:
		OutputDebugString("DDERR_NOCOLORCONVHW\n");
		break;
	case DDERR_NOCOLORKEY:
		OutputDebugString("DDERR_NOCOLORKEY\n");
		break;
	case DDERR_NOCOLORKEYHW:
		OutputDebugString("DDERR_NOCOLORKEYHW\n");
		break;
	case DDERR_NOCOOPERATIVELEVELSET:
		OutputDebugString("DDERR_NOCOOPERATIVELEVELSET\n");
		break;
	case DDERR_NODC:
		OutputDebugString("DDERR_NODC\n");
		break;
	case DDERR_NODDROPSHW:
		OutputDebugString("DDERR_NODDROPSHW\n");
		break;
	case DDERR_NODIRECTDRAWHW:
		OutputDebugString("DDERR_NODIRECTDRAWHW\n");
		break;
	case DDERR_NODIRECTDRAWSUPPORT:
		OutputDebugString("DDERR_NODIRECTDRAWSUPPORT\n");
		break;
	case DDERR_NODRIVERSUPPORT:
		OutputDebugString("DDERR_NODRIVERSUPPORT\n");
		break;
	case DDERR_NOEMULATION:
		OutputDebugString("DDERR_NOEMULATION\n");
		break;
	case DDERR_NOEXCLUSIVEMODE:
		OutputDebugString("DDERR_NOEXCLUSIVEMODE\n");
		break;
	case DDERR_NOFLIPHW:
		OutputDebugString("DDERR_NOFLIPHW\n");
		break;
	case DDERR_NOFOCUSWINDOW:
		OutputDebugString("DDERR_NOFOCUSWINDOW\n");
		break;
	case DDERR_NOGDI:
		OutputDebugString("DDERR_NOGDI\n");
		break;
	case DDERR_NOHWND:
		OutputDebugString("DDERR_NOHWND\n");
		break;
	case DDERR_NOMIPMAPHW:
		OutputDebugString("DDERR_NOMIPMAPHW\n");
		break;
	case DDERR_NOMIRRORHW:
		OutputDebugString("DDERR_NOMIRRORHW\n");
		break;
	case DDERR_NOMONITORINFORMATION:
		OutputDebugString("DDERR_NOMONITORINFORMATION\n");
		break;
	case DDERR_NONONLOCALVIDMEM:
		OutputDebugString("DDERR_NONONLOCALVIDMEM\n");
		break;
	case DDERR_NOOPTIMIZEHW:
		OutputDebugString("DDERR_NOOPTIMIZEHW\n");
		break;
	case DDERR_NOOVERLAYDEST:
		OutputDebugString("DDERR_NOOVERLAYDEST\n");
		break;
	case DDERR_NOOVERLAYHW:
		OutputDebugString("DDERR_NOOVERLAYHW\n");
		break;
	case DDERR_NOPALETTEATTACHED:
		OutputDebugString("DDERR_NOPALETTEATTACHED\n");
		break;
	case DDERR_NOPALETTEHW:
		OutputDebugString("DDERR_NOPALETTEHW\n");
		break;
	case DDERR_NORASTEROPHW:
		OutputDebugString("DDERR_NORASTEROPHW\n");
		break;
	case DDERR_NOROTATIONHW:
		OutputDebugString("DDERR_NOROTATIONHW\n");
		break;
	case DDERR_NOSTEREOHARDWARE:
		OutputDebugString("DDERR_NOSTEREOHARDWARE\n");
		break;
	case DDERR_NOSTRETCHHW:
		OutputDebugString("DDERR_NOSTRETCHHW\n");
		break;
	case DDERR_NOSURFACELEFT:
		OutputDebugString("DDERR_NOSURFACELEFT\n");
		break;
	case DDERR_NOT4BITCOLOR:
		OutputDebugString("DDERR_NOT4BITCOLOR\n");
		break;
	case DDERR_NOT4BITCOLORINDEX:
		OutputDebugString("DDERR_NOT4BITCOLORINDEX\n");
		break;
	case DDERR_NOT8BITCOLOR:
		OutputDebugString("DDERR_NOT8BITCOLOR\n");
		break;
	case DDERR_NOTAOVERLAYSURFACE:
		OutputDebugString("DDERR_NOTAOVERLAYSURFACE\n");
		break;
	case DDERR_NOTEXTUREHW:
		OutputDebugString("DDERR_NOTEXTUREHW\n");
		break;
	case DDERR_NOTFLIPPABLE:
		OutputDebugString("DDERR_NOTFLIPPABLE\n");
		break;
	case DDERR_NOTFOUND:
		OutputDebugString("DDERR_NOTFOUND\n");
		break;
	case DDERR_NOTINITIALIZED:
		OutputDebugString("DDERR_NOTINITIALIZED\n");
		break;
	case DDERR_NOTLOADED:
		OutputDebugString("DDERR_NOTLOADED\n");
		break;
	case DDERR_NOTLOCKED:
		OutputDebugString("DDERR_NOTLOCKED\n");
		break;
	case DDERR_NOTPAGELOCKED:
		OutputDebugString("DDERR_NOTPAGELOCKED\n");
		break;
	case DDERR_NOTPALETTIZED:
		OutputDebugString("DDERR_NOTPALETTIZED\n");
		break;
	case DDERR_NOVSYNCHW:
		OutputDebugString("DDERR_NOVSYNCHW\n");
		break;
	case DDERR_NOZBUFFERHW:
		OutputDebugString("DDERR_NOZBUFFERHW\n");
		break;
	case DDERR_NOZOVERLAYHW:
		OutputDebugString("DDERR_NOZOVERLAYHW\n");
		break;
	case DDERR_OUTOFCAPS:
		OutputDebugString("DDERR_OUTOFCAPS\n");
		break;
	case DDERR_OUTOFMEMORY:
		OutputDebugString("DDERR_OUTOFMEMORY\n");
		break;
	case DDERR_OUTOFVIDEOMEMORY:
		OutputDebugString("DDERR_OUTOFVIDEOMEMORY\n");
		break;
	case DDERR_OVERLAPPINGRECTS:
		OutputDebugString("DDERR_OVERLAPPINGRECTS\n");
		break;
	case DDERR_OVERLAYCANTCLIP:
		OutputDebugString("DDERR_OVERLAYCANTCLIP\n");
		break;
	case DDERR_OVERLAYCOLORKEYONLYONEACTIVE:
		OutputDebugString("DDERR_OVERLAYCOLORKEYONLYONEACTIVE\n");
		break;
	case DDERR_OVERLAYNOTVISIBLE:
		OutputDebugString("DDERR_OVERLAYNOTVISIBLE\n");
		break;
	case DDERR_PALETTEBUSY:
		OutputDebugString("DDERR_PALETTEBUSY\n");
		break;
	case DDERR_PRIMARYSURFACEALREADYEXISTS:
		OutputDebugString("DDERR_PRIMARYSURFACEALREADYEXISTS\n");
		break;
	case DDERR_REGIONTOOSMALL:
		OutputDebugString("DDERR_REGIONTOOSMALL\n");
		break;
	case DDERR_SURFACEALREADYATTACHED:
		OutputDebugString("DDERR_SURFACEALREADYATTACHED\n");
		break;
	case DDERR_SURFACEALREADYDEPENDENT:
		OutputDebugString("DDERR_SURFACEALREADYDEPENDENT\n");
		break;
	case DDERR_SURFACEBUSY:
		OutputDebugString("DDERR_SURFACEBUSY\n");
		break;
	case DDERR_SURFACEISOBSCURED:
		OutputDebugString("DDERR_SURFACEISOBSCURED\n");
		break;
	case DDERR_SURFACELOST:
		OutputDebugString("DDERR_SURFACELOST\n");
		break;
	case DDERR_SURFACENOTATTACHED:
		OutputDebugString("DDERR_SURFACENOTATTACHED\n");
		break;
	case DDERR_TESTFINISHED:
		OutputDebugString("DDERR_TESTFINISHED\n");
		break;
	case DDERR_TOOBIGHEIGHT:
		OutputDebugString("DDERR_TOOBIGHEIGHT\n");
		break;
	case DDERR_TOOBIGSIZE:
		OutputDebugString("DDERR_TOOBIGSIZE\n");
		break;
	case DDERR_TOOBIGWIDTH:
		OutputDebugString("DDERR_TOOBIGWIDTH\n");
		break;
	case DDERR_UNSUPPORTED:
		OutputDebugString("DDERR_UNSUPPORTED\n");
		break;
	case DDERR_UNSUPPORTEDFORMAT:
		OutputDebugString("DDERR_UNSUPPORTEDFORMAT\n");
		break;
	case DDERR_UNSUPPORTEDMASK:
		OutputDebugString("DDERR_UNSUPPORTEDMASK\n");
		break;
	case DDERR_UNSUPPORTEDMODE:
		OutputDebugString("DDERR_UNSUPPORTEDMODE\n");
		break;
	case DDERR_VERTICALBLANKINPROGRESS:
		OutputDebugString("DDERR_VERTICALBLANKINPROGRESS\n");
		break;
	case DDERR_VIDEONOTACTIVE:
		OutputDebugString("DDERR_VIDEONOTACTIVE\n");
		break;
	case DDERR_WASSTILLDRAWING:
		OutputDebugString("DDERR_WASSTILLDRAWING\n");
		break;
	case DDERR_WRONGMODE:
		OutputDebugString("DDERR_WRONGMODE\n");
		break;
	case DDERR_XALIGN:
		OutputDebugString("DDERR_XALIGN\n");
		break;
	default:
		OutputDebugString("Unknown DirectDraw Error\n");
		break;
	}
}

void Debugger::printErrorD3D(HRESULT value)
{
	switch (value)
	{
	case D3D_OK:
		OutputDebugString("D3D_OK\n");
		break;
	case D3DERR_BADMAJORVERSION:
		OutputDebugString("D3DERR_BADMAJORVERSION\n");
		break;
	case D3DERR_BADMINORVERSION:
		OutputDebugString("D3DERR_BADMINORVERSION\n");
		break;
	case D3DERR_COLORKEYATTACHED:
		OutputDebugString("D3DERR_COLORKEYATTACHED\n");
		break;
	case D3DERR_CONFLICTINGTEXTUREFILTER:
		OutputDebugString("D3DERR_CONFLICTINGTEXTUREFILTER\n");
		break;
	case D3DERR_CONFLICTINGTEXTUREPALETTE:
		OutputDebugString("D3DERR_CONFLICTINGTEXTUREPALETTE\n");
		break;
	case D3DERR_CONFLICTINGRENDERSTATE:
		OutputDebugString("D3DERR_CONFLICTINGRENDERSTATE\n");
		break;
	case D3DERR_DEVICEAGGREGATED:
		OutputDebugString("D3DERR_DEVICEAGGREGATED\n");
		break;
	case D3DERR_EXECUTE_CLIPPED_FAILED:
		OutputDebugString("D3DERR_EXECUTE_CLIPPED_FAILED\n");
		break;
	case D3DERR_EXECUTE_CREATE_FAILED:
		OutputDebugString("D3DERR_EXECUTE_CREATE_FAILED\n");
		break;
	case D3DERR_EXECUTE_DESTROY_FAILED:
		OutputDebugString("D3DERR_EXECUTE_DESTROY_FAILED\n");
		break;
	case D3DERR_EXECUTE_FAILED:
		OutputDebugString("D3DERR_EXECUTE_FAILED\n");
		break;
	case D3DERR_EXECUTE_LOCK_FAILED:
		OutputDebugString("D3DERR_EXECUTE_LOCK_FAILED\n");
		break;
	case D3DERR_EXECUTE_LOCKED:
		OutputDebugString("D3DERR_EXECUTE_LOCKED\n");
		break;
	case D3DERR_EXECUTE_NOT_LOCKED:
		OutputDebugString("D3DERR_EXECUTE_NOT_LOCKED\n");
		break;
	case D3DERR_EXECUTE_UNLOCK_FAILED:
		OutputDebugString("D3DERR_EXECUTE_UNLOCK_FAILED\n");
		break;
	case D3DERR_INBEGIN:
		OutputDebugString("D3DERR_INBEGIN\n");
		break;
	case D3DERR_INBEGINSTATEBLOCK:
		OutputDebugString("D3DERR_INBEGINSTATEBLOCK\n");
		break;
	case D3DERR_INITFAILED:
		OutputDebugString("D3DERR_INITFAILED\n");
		break;
	case D3DERR_INVALID_DEVICE:
		OutputDebugString("D3DERR_INVALID_DEVICE\n");
		break;
	case D3DERR_INVALIDCURRENTVIEWPORT:
		OutputDebugString("D3DERR_INVALIDCURRENTVIEWPORT\n");
		break;
	case D3DERR_INVALIDMATRIX:
		OutputDebugString("D3DERR_INVALIDMATRIX\n");
		break;
	case D3DERR_INVALIDPALETTE:
		OutputDebugString("D3DERR_INVALIDPALETTE\n");
		break;
	case D3DERR_INVALIDPRIMITIVETYPE:
		OutputDebugString("D3DERR_INVALIDPRIMITIVETYPE\n");
		break;
	case D3DERR_INVALIDRAMPTEXTURE:
		OutputDebugString("D3DERR_INVALIDRAMPTEXTURE\n");
		break;
	case D3DERR_INVALIDSTATEBLOCK:
		OutputDebugString("D3DERR_INVALIDSTATEBLOCK\n");
		break;
	case D3DERR_INVALIDVERTEXFORMAT:
		OutputDebugString("D3DERR_INVALIDVERTEXFORMAT\n");
		break;
	case D3DERR_INVALIDVERTEXTYPE:
		OutputDebugString("D3DERR_INVALIDVERTEXTYPE\n");
		break;
	case D3DERR_LIGHT_SET_FAILED:
		OutputDebugString("D3DERR_LIGHT_SET_FAILED\n");
		break;
	case D3DERR_LIGHTHASVIEWPORT:
		OutputDebugString("D3DERR_LIGHTHASVIEWPORT\n");
		break;
	case D3DERR_LIGHTNOTINTHISVIEWPORT:
		OutputDebugString("D3DERR_LIGHTNOTINTHISVIEWPORT\n");
		break;
	case D3DERR_MATERIAL_CREATE_FAILED:
		OutputDebugString("D3DERR_MATERIAL_CREATE_FAILED\n");
		break;
	case D3DERR_MATERIAL_DESTROY_FAILED:
		OutputDebugString("D3DERR_MATERIAL_DESTROY_FAILED\n");
		break;
	case D3DERR_MATERIAL_GETDATA_FAILED:
		OutputDebugString("D3DERR_MATERIAL_GETDATA_FAILED\n");
		break;
	case D3DERR_MATERIAL_SETDATA_FAILED:
		OutputDebugString("D3DERR_MATERIAL_SETDATA_FAILED\n");
		break;
	case D3DERR_MATRIX_CREATE_FAILED:
		OutputDebugString("D3DERR_MATRIX_CREATE_FAILED\n");
		break;
	case D3DERR_MATRIX_DESTROY_FAILED:
		OutputDebugString("D3DERR_MATRIX_DESTROY_FAILED\n");
		break;
	case D3DERR_MATRIX_GETDATA_FAILED:
		OutputDebugString("D3DERR_MATRIX_GETDATA_FAILED\n");
		break;
	case D3DERR_MATRIX_SETDATA_FAILED:
		OutputDebugString("D3DERR_MATRIX_SETDATA_FAILED\n");
		break;
	case D3DERR_NOCURRENTVIEWPORT:
		OutputDebugString("D3DERR_NOCURRENTVIEWPORT\n");
		break;
	case D3DERR_NOTINBEGIN:
		OutputDebugString("D3DERR_NOTINBEGIN\n");
		break;
	case D3DERR_NOTINBEGINSTATEBLOCK:
		OutputDebugString("D3DERR_NOTINBEGINSTATEBLOCK\n");
		break;
	case D3DERR_NOVIEWPORTS:
		OutputDebugString("D3DERR_NOVIEWPORTS\n");
		break;
	case D3DERR_SCENE_BEGIN_FAILED:
		OutputDebugString("D3DERR_SCENE_BEGIN_FAILED\n");
		break;
	case D3DERR_SCENE_END_FAILED:
		OutputDebugString("D3DERR_SCENE_END_FAILED\n");
		break;
	case D3DERR_SCENE_IN_SCENE:
		OutputDebugString("D3DERR_SCENE_IN_SCENE\n");
		break;
	case D3DERR_SCENE_NOT_IN_SCENE:
		OutputDebugString("D3DERR_SCENE_NOT_IN_SCENE\n");
		break;
	case D3DERR_SETVIEWPORTDATA_FAILED:
		OutputDebugString("D3DERR_SETVIEWPORTDATA_FAILED\n");
		break;
	case D3DERR_STENCILBUFFER_NOTPRESENT:
		OutputDebugString("D3DERR_STENCILBUFFER_NOTPRESENT\n");
		break;
	case D3DERR_SURFACENOTINVIDMEM:
		OutputDebugString("D3DERR_SURFACENOTINVIDMEM\n");
		break;
	case D3DERR_TEXTURE_BADSIZE:
		OutputDebugString("D3DERR_TEXTURE_BADSIZE\n");
		break;
	case D3DERR_TEXTURE_CREATE_FAILED:
		OutputDebugString("D3DERR_TEXTURE_CREATE_FAILED\n");
		break;
	case D3DERR_TEXTURE_DESTROY_FAILED:
		OutputDebugString("D3DERR_TEXTURE_DESTROY_FAILED\n");
		break;
	case D3DERR_TEXTURE_GETSURF_FAILED:
		OutputDebugString("D3DERR_TEXTURE_GETSURF_FAILED\n");
		break;
	case D3DERR_TEXTURE_LOAD_FAILED:
		OutputDebugString("D3DERR_TEXTURE_LOAD_FAILED\n");
		break;
	case D3DERR_TEXTURE_LOCK_FAILED:
		OutputDebugString("D3DERR_TEXTURE_LOCK_FAILED\n");
		break;
	case D3DERR_TEXTURE_LOCKED:
		OutputDebugString("D3DERR_TEXTURE_LOCKED\n");
		break;
	case D3DERR_TEXTURE_NO_SUPPORT:
		OutputDebugString("D3DERR_TEXTURE_NO_SUPPORT\n");
		break;
	case D3DERR_TEXTURE_NOT_LOCKED:
		OutputDebugString("D3DERR_TEXTURE_NOT_LOCKED\n");
		break;
	case D3DERR_TEXTURE_SWAP_FAILED:
		OutputDebugString("D3DERR_TEXTURE_SWAP_FAILED\n");
		break;
	case D3DERR_TEXTURE_UNLOCK_FAILED:
		OutputDebugString("D3DERR_TEXTURE_UNLOCK_FAILED\n");
		break;
	case D3DERR_TOOMANYOPERATIONS:
		OutputDebugString("D3DERR_TOOMANYOPERATIONS\n");
		break;
	case D3DERR_TOOMANYPRIMITIVES:
		OutputDebugString("D3DERR_TOOMANYPRIMITIVES\n");
		break;
	case D3DERR_UNSUPPORTEDALPHAARG:
		OutputDebugString("D3DERR_UNSUPPORTEDALPHAARG\n");
		break;
	case D3DERR_UNSUPPORTEDALPHAOPERATION:
		OutputDebugString("D3DERR_UNSUPPORTEDALPHAOPERATION\n");
		break;
	case D3DERR_UNSUPPORTEDCOLORARG:
		OutputDebugString("D3DERR_UNSUPPORTEDCOLORARG\n");
		break;
	case D3DERR_UNSUPPORTEDCOLOROPERATION:
		OutputDebugString("D3DERR_UNSUPPORTEDCOLOROPERATION\n");
		break;
	case D3DERR_UNSUPPORTEDFACTORVALUE:
		OutputDebugString("D3DERR_UNSUPPORTEDFACTORVALUE\n");
		break;
	case D3DERR_UNSUPPORTEDTEXTUREFILTER:
		OutputDebugString("D3DERR_UNSUPPORTEDTEXTUREFILTER\n");
		break;
	case D3DERR_VBUF_CREATE_FAILED:
		OutputDebugString("D3DERR_VBUF_CREATE_FAILED\n");
		break;
	case D3DERR_VERTEXBUFFERLOCKED:
		OutputDebugString("D3DERR_VERTEXBUFFERLOCKED\n");
		break;
	case D3DERR_VERTEXBUFFEROPTIMIZED:
		OutputDebugString("D3DERR_VERTEXBUFFEROPTIMIZED\n");
		break;
	case D3DERR_VERTEXBUFFERUNLOCKFAILED:
		OutputDebugString("D3DERR_VERTEXBUFFERUNLOCKFAILED\n");
		break;
	case D3DERR_VIEWPORTDATANOTSET:
		OutputDebugString("D3DERR_VIEWPORTDATANOTSET\n");
		break;
	case D3DERR_VIEWPORTHASNODEVICE:
		OutputDebugString("D3DERR_VIEWPORTHASNODEVICE\n");
		break;
	case D3DERR_WRONGTEXTUREFORMAT:
		OutputDebugString("D3DERR_WRONGTEXTUREFORMAT\n");
		break;
	case D3DERR_ZBUFF_NEEDS_SYSTEMMEMORY:
		OutputDebugString("D3DERR_ZBUFF_NEEDS_SYSTEMMEMORY\n");
		break;
	case D3DERR_ZBUFF_NEEDS_VIDEOMEMORY:
		OutputDebugString("D3DERR_ZBUFF_NEEDS_VIDEOMEMORY\n");
		break;
	case D3DERR_ZBUFFER_NOTPRESENT:
		OutputDebugString("D3DERR_ZBUFFER_NOTPRESENT\n");
		break;
	default:
		OutputDebugString("Unknown Direct3D Error\n");
		break;
	}
}

void Debugger::printErrorDInput(HRESULT value)
{
	switch (value)
	{
	case DI_OK:
		OutputDebugString("DI_OK\n");
		break;
	case DI_BUFFEROVERFLOW:
//	case DI_NOEFFECT:
//	case DI_NOTATTACHED:
//	case DI_PROPNOEFFECT:
		OutputDebugString("DI_BUFFEROVERFLOW or");
		OutputDebugString("DI_NOEFFECT or");
		OutputDebugString("DI_NOTATTACHED or");
		OutputDebugString("DI_PROPNOEFFECT\n");
		break;
	case DI_DOWNLOADSKIPPED:
		OutputDebugString("DI_DOWNLOADSKIPPED\n");
		break;
	case DI_EFFECTRESTARTED:
		OutputDebugString("DI_EFFECTRESTARTED\n");
		break;
	case DI_POLLEDDEVICE:
		OutputDebugString("DI_POLLEDDEVICE\n");
		break;
	case DI_TRUNCATED:
		OutputDebugString("DI_TRUNCATED\n");
		break;
	case DI_TRUNCATEDANDRESTARTED:
		OutputDebugString("DI_TRUNCATEDANDRESTARTED\n");
		break;
	case DIERR_ACQUIRED:
		OutputDebugString("DIERR_ACQUIRED\n");
		break;
	case DIERR_ALREADYINITIALIZED:
		OutputDebugString("DIERR_ALREADYINITIALIZED\n");
		break;
	case DIERR_BADDRIVERVER:
		OutputDebugString("DIERR_BADDRIVERVER\n");
		break;
	case DIERR_BETADIRECTINPUTVERSION:
		OutputDebugString("DIERR_BETADIRECTINPUTVERSION\n");
		break;
	case DIERR_DEVICEFULL:
		OutputDebugString("DIERR_DEVICEFULL\n");
		break;
	case DIERR_DEVICENOTREG:
		OutputDebugString("DIERR_DEVICENOTREG\n");
		break;
	case DIERR_EFFECTPLAYING:
		OutputDebugString("DIERR_EFFECTPLAYING\n");
		break;
	case DIERR_HASEFFECTS:
		OutputDebugString("DIERR_HASEFFECTS\n");
		break;
	case DIERR_GENERIC:
		OutputDebugString("DIERR_GENERIC\n");
		break;
	case DIERR_HANDLEEXISTS:
//	case DIERR_OTHERAPPHASPRIO:
//	case DIERR_READONLY:
		OutputDebugString("DIERR_HANDLEEXISTS or");
		OutputDebugString("DIERR_OTHERAPPHASPRIO or");
		OutputDebugString("DIERR_READONLY\n");
		break;
	case DIERR_INCOMPLETEEFFECT:
		OutputDebugString("DIERR_INCOMPLETEEFFECT\n");
		break;
	case DIERR_INPUTLOST:
		OutputDebugString("DIERR_INPUTLOST\n");
		break;
	case DIERR_INVALIDPARAM:
		OutputDebugString("DIERR_INVALIDPARAM\n");
		break;
	case DIERR_MOREDATA:
		OutputDebugString("DIERR_MOREDATA\n");
		break;
	case DIERR_NOAGGREGATION:
		OutputDebugString("DIERR_NOAGGREGATION\n");
		break;
	case DIERR_NOINTERFACE:
		OutputDebugString("DIERR_NOINTERFACE\n");
		break;
	case DIERR_NOTACQUIRED:
		OutputDebugString("DIERR_NOTACQUIRED\n");
		break;
	case DIERR_NOTBUFFERED:
		OutputDebugString("DIERR_NOTBUFFERED\n");
		break;
	case DIERR_NOTDOWNLOADED:
		OutputDebugString("DIERR_NOTDOWNLOADED\n");
		break;
	case DIERR_NOTEXCLUSIVEACQUIRED:
		OutputDebugString("DIERR_NOTEXCLUSIVEACQUIRED\n");
		break;
	case DIERR_NOTFOUND:
//	case DIERR_OBJECTNOTFOUND:
		OutputDebugString("DIERR_NOTFOUND or");
		OutputDebugString("DIERR_OBJECTNOTFOUND\n");
		break;
	case DIERR_NOTINITIALIZED:
		OutputDebugString("DIERR_NOTINITIALIZED\n");
		break;
	case DIERR_OLDDIRECTINPUTVERSION:
		OutputDebugString("DIERR_OLDDIRECTINPUTVERSION\n");
		break;
	case DIERR_OUTOFMEMORY:
		OutputDebugString("DIERR_OUTOFMEMORY\n");
		break;
	case DIERR_REPORTFULL:
		OutputDebugString("DIERR_REPORTFULL\n");
		break;
	case DIERR_UNPLUGGED:
		OutputDebugString("DIERR_UNPLUGGED\n");
		break;
	case DIERR_UNSUPPORTED:
		OutputDebugString("DIERR_UNSUPPORTED\n");
		break;
	case E_HANDLE:
		OutputDebugString("E_HANDLE\n");
		break;
	case E_PENDING:
		OutputDebugString("E_PENDING\n");
		break;
	default:
		OutputDebugString("Unknown DirectInput Error\n");
		break;
	}
}

void Debugger::printErrorDSound(HRESULT value)
{
	switch (value)
	{
	case DS_OK:
		OutputDebugString("DS_OK\n");
		break;
	case DSERR_ACCESSDENIED:
		OutputDebugString("DSERR_ACCESSDENIED\n");
		break;
	case DSERR_ALLOCATED:
		OutputDebugString("DSERR_ALLOCATED\n");
		break;
	case DSERR_ALREADYINITIALIZED:
		OutputDebugString("DSERR_ALREADYINITIALIZED\n");
		break;
	case DSERR_BADFORMAT:
		OutputDebugString("DSERR_BADFORMAT\n");
		break;
	case DSERR_BUFFERLOST:
		OutputDebugString("DSERR_BUFFERLOST\n");
		break;
	case DSERR_CONTROLUNAVAIL:
		OutputDebugString("DSERR_CONTROLUNAVAIL\n");
		break;
	case DSERR_GENERIC:
		OutputDebugString("DSERR_GENERIC\n");
		break;
//	case DSERR_HWUNAVAIL:
//		OutputDebugString("DSERR_HWUNAVAIL\n");
//		break;
	case DSERR_INVALIDCALL:
		OutputDebugString("DSERR_INVALIDCALL\n");
		break;
	case DSERR_INVALIDPARAM:
		OutputDebugString("DSERR_INVALIDPARAM\n");
		break;
	case DSERR_NOAGGREGATION:
		OutputDebugString("DSERR_NOAGGREGATION\n");
		break;
	case DSERR_NODRIVER:
		OutputDebugString("DSERR_NODRIVER\n");
		break;
	case DSERR_NOINTERFACE:
		OutputDebugString("DSERR_NOINTERFACE\n");
		break;
	case DSERR_OTHERAPPHASPRIO:
		OutputDebugString("DSERR_OTHERAPPHASPRIO\n");
		break;
	case DSERR_OUTOFMEMORY:
		OutputDebugString("DSERR_OUTOFMEMORY\n");
		break;
	case DSERR_PRIOLEVELNEEDED:
		OutputDebugString("DSERR_PRIOLEVELNEEDED\n");
		break;
	case DSERR_UNINITIALIZED:
		OutputDebugString("DSERR_UNINITIALIZED\n");
		break;
	case DSERR_UNSUPPORTED:
		OutputDebugString("DSERR_UNSUPPORTED\n");
		break;
	default:
		OutputDebugString("Unknown DirectSound Error\n");
		break;
	}
}

void Debugger::printErrorDMusic(HRESULT value)
{
	switch (value)
	{
	case S_OK:
		OutputDebugString("S_OK\n");
		break;
	case S_FALSE:
		OutputDebugString("S_FALSE\n");
		break;
	case DMUS_E_ALL_TOOLS_FAILED:
		OutputDebugString("DMUS_E_ALL_TOOLS_FAILED\n");
		break;
	case DMUS_E_ALL_TRACKS_FAILED:
		OutputDebugString("DMUS_E_ALL_TRACKS_FAILED\n");
		break;
	case DMUS_E_ALREADY_ACTIVATED:
		OutputDebugString("DMUS_E_ALREADY_ACTIVATED\n");
		break;
	case DMUS_E_ALREADY_DOWNLOADED:
		OutputDebugString("DMUS_E_ALREADY_DOWNLOADED\n");
		break;
	case DMUS_E_ALREADY_EXISTS:
		OutputDebugString("DMUS_E_ALREADY_EXISTS\n");
		break;
	case DMUS_E_ALREADY_INITED:
		OutputDebugString("DMUS_E_ALREADY_INITED\n");
		break;
	case DMUS_E_ALREADY_LOADED:
		OutputDebugString("DMUS_E_ALREADY_LOADED\n");
		break;
	case DMUS_E_ALREADY_SENT:
		OutputDebugString("DMUS_E_ALREADY_SENT\n");
		break;
	case DMUS_E_ALREADYCLOSED:
		OutputDebugString("DMUS_E_ALREADYCLOSED\n");
		break;
	case DMUS_E_ALREADYOPEN:
		OutputDebugString("DMUS_E_ALREADYOPEN\n");
		break;
	case DMUS_E_BADARTICULATION:
		OutputDebugString("DMUS_E_BADARTICULATION\n");
		break;
	case DMUS_E_BADINSTRUMENT:
		OutputDebugString("DMUS_E_BADINSTRUMENT\n");
		break;
	case DMUS_E_BADOFFSETTABLE:
		OutputDebugString("DMUS_E_BADOFFSETTABLE\n");
		break;
	case DMUS_E_BADWAVE:
		OutputDebugString("DMUS_E_BADWAVE\n");
		break;
	case DMUS_E_BADWAVELINK:
		OutputDebugString("DMUS_E_BADWAVELINK\n");
		break;
	case DMUS_E_BUFFER_EMPTY:
		OutputDebugString("DMUS_E_BUFFER_EMPTY\n");
		break;
	case DMUS_E_BUFFER_FULL:
		OutputDebugString("DMUS_E_BUFFER_FULL\n");
		break;
	case DMUS_E_BUFFERNOTAVAILABLE:
		OutputDebugString("DMUS_E_BUFFERNOTAVAILABLE\n");
		break;
	case DMUS_E_BUFFERNOTSET:
		OutputDebugString("DMUS_E_BUFFERNOTSET\n");
		break;
//	case DMUS_E_CANNOT_CONVERT:
//		OutputDebugString("DMUS_E_CANNOT_CONVERT\n");
//		break;
	case DMUS_E_CANNOT_FREE:
		OutputDebugString("DMUS_E_CANNOT_FREE\n");
		break;
	case DMUS_E_CANNOT_OPEN_PORT:
		OutputDebugString("DMUS_E_CANNOT_OPEN_PORT\n");
		break;
	case DMUS_E_CANNOTREAD:
		OutputDebugString("DMUS_E_CANNOTREAD\n");
		break;
	case DMUS_E_CANNOTSEEK:
		OutputDebugString("DMUS_E_CANNOTSEEK\n");
		break;
	case DMUS_E_CANNOTWRITE:
		OutputDebugString("DMUS_E_CANNOTWRITE\n");
		break;
	case DMUS_E_CHUNKNOTFOUND:
		OutputDebugString("DMUS_E_CHUNKNOTFOUND\n");
		break;
	case DMUS_E_DESCEND_CHUNK_FAIL:
		OutputDebugString("DMUS_E_DESCEND_CHUNK_FAIL\n");
		break;
	case DMUS_E_DEVICE_IN_USE:
		OutputDebugString("DMUS_E_DEVICE_IN_USE\n");
		break;
	case DMUS_E_DMUSIC_RELEASED:
		OutputDebugString("DMUS_E_DMUSIC_RELEASED\n");
		break;
	case DMUS_E_DRIVER_FAILED:
		OutputDebugString("DMUS_E_DRIVER_FAILED\n");
		break;
	case DMUS_E_DSOUND_ALREADY_SET:
		OutputDebugString("DMUS_E_DSOUND_ALREADY_SET\n");
		break;
	case DMUS_E_DSOUND_NOT_SET:
		OutputDebugString("DMUS_E_DSOUND_NOT_SET\n");
		break;
	case DMUS_E_GET_UNSUPPORTED:
		OutputDebugString("DMUS_E_GET_UNSUPPORTED\n");
		break;
	case DMUS_E_INSUFFICIENTBUFFER:
		OutputDebugString("DMUS_E_INSUFFICIENTBUFFER\n");
		break;
	case DMUS_E_INVALID_BAND:
		OutputDebugString("DMUS_E_INVALID_BAND\n");
		break;
	case DMUS_E_INVALID_DOWNLOADID:
		OutputDebugString("DMUS_E_INVALID_DOWNLOADID\n");
		break;
	case DMUS_E_INVALID_EVENT:
		OutputDebugString("DMUS_E_INVALID_EVENT\n");
		break;
	case DMUS_E_INVALID_TOOL_HDR:
		OutputDebugString("DMUS_E_INVALID_TOOL_HDR\n");
		break;
	case DMUS_E_INVALID_TRACK_HDR:
		OutputDebugString("DMUS_E_INVALID_TRACK_HDR\n");
		break;
	case DMUS_E_INVALIDBUFFER:
		OutputDebugString("DMUS_E_INVALIDBUFFER\n");
		break;
	case DMUS_E_INVALIDFILE:
		OutputDebugString("DMUS_E_INVALIDFILE\n");
		break;
	case DMUS_E_INVALIDOFFSET:
		OutputDebugString("DMUS_E_INVALIDOFFSET\n");
		break;
	case DMUS_E_INVALIDPATCH:
		OutputDebugString("DMUS_E_INVALIDPATCH\n");
		break;
	case DMUS_E_INVALIDPOS:
		OutputDebugString("DMUS_E_INVALIDPOS\n");
		break;
	case DMUS_E_LOADER_BADPATH:
		OutputDebugString("DMUS_E_LOADER_BADPATH\n");
		break;
	case DMUS_E_LOADER_FAILEDCREATE:
		OutputDebugString("DMUS_E_LOADER_FAILEDCREATE\n");
		break;
	case DMUS_E_LOADER_FAILEDOPEN:
		OutputDebugString("DMUS_E_LOADER_FAILEDOPEN\n");
		break;
	case DMUS_E_LOADER_FORMATNOTSUPPORTED:
		OutputDebugString("DMUS_E_LOADER_FORMATNOTSUPPORTED\n");
		break;
	case DMUS_E_LOADER_NOCLASSID:
		OutputDebugString("DMUS_E_LOADER_NOCLASSID\n");
		break;
	case DMUS_E_LOADER_NOFILENAME:
		OutputDebugString("DMUS_E_LOADER_NOFILENAME\n");
		break;
	case DMUS_E_LOADER_OBJECTNOTFOUND:
		OutputDebugString("DMUS_E_LOADER_OBJECTNOTFOUND\n");
		break;
	case DMUS_E_NO_MASTER_CLOCK:
		OutputDebugString("DMUS_E_NO_MASTER_CLOCK\n");
		break;
	case DMUS_E_NOARTICULATION:
		OutputDebugString("DMUS_E_NOARTICULATION\n");
		break;
	case DMUS_E_NOSYNTHSINK:
		OutputDebugString("DMUS_E_NOSYNTHSINK\n");
		break;
	case DMUS_E_NOT_DOWNLOADED_TO_PORT:
		OutputDebugString("DMUS_E_NOT_DOWNLOADED_TO_PORT\n");
		break;
	case DMUS_E_NOT_FOUND:
		OutputDebugString("DMUS_E_NOT_FOUND\n");
		break;
	case DMUS_E_NOT_INIT:
		OutputDebugString("DMUS_E_NOT_INIT\n");
		break;
	case DMUS_E_NOTADLSCOL:
		OutputDebugString("DMUS_E_NOTADLSCOL\n");
		break;
	case DMUS_E_NOTMONO:
		OutputDebugString("DMUS_E_NOTMONO\n");
		break;
	case DMUS_E_NOTPCM:
		OutputDebugString("DMUS_E_NOTPCM\n");
		break;
	case DMUS_E_OUT_OF_RANGE:
		OutputDebugString("DMUS_E_OUT_OF_RANGE\n");
		break;
	case DMUS_E_PORT_NOT_CAPTURE:
		OutputDebugString("DMUS_E_PORT_NOT_CAPTURE\n");
		break;
	case DMUS_E_PORT_NOT_RENDER:
		OutputDebugString("DMUS_E_PORT_NOT_RENDER\n");
		break;
	case DMUS_E_PORTS_OPEN:
		OutputDebugString("DMUS_E_PORTS_OPEN\n");
		break;
	case DMUS_E_SEGMENT_INIT_FAILED:
		OutputDebugString("DMUS_E_SEGMENT_INIT_FAILED\n");
		break;
	case DMUS_E_SET_UNSUPPORTED:
		OutputDebugString("DMUS_E_SET_UNSUPPORTED\n");
		break;
	case DMUS_E_SYNTHACTIVE:
		OutputDebugString("DMUS_E_SYNTHACTIVE\n");
		break;
	case DMUS_E_SYNTHINACTIVE:
		OutputDebugString("DMUS_E_SYNTHINACTIVE\n");
		break;
	case DMUS_E_SYNTHNOTCONFIGURED:
		OutputDebugString("DMUS_E_SYNTHNOTCONFIGURED\n");
		break;
	case DMUS_E_TIME_PAST:
		OutputDebugString("DMUS_E_TIME_PAST\n");
		break;
	case DMUS_E_TOOL_HDR_NOT_FIRST_CK:
		OutputDebugString("DMUS_E_TOOL_HDR_NOT_FIRST_CK\n");
		break;
	case DMUS_E_TRACK_HDR_NOT_FIRST_CK:
		OutputDebugString("DMUS_E_TRACK_HDR_NOT_FIRST_CK\n");
		break;
	case DMUS_E_TRACK_NOT_FOUND:
		OutputDebugString("DMUS_E_TRACK_NOT_FOUND\n");
		break;
	case DMUS_E_TYPE_DISABLED:
		OutputDebugString("DMUS_E_TYPE_DISABLED\n");
		break;
	case DMUS_E_TYPE_UNSUPPORTED:
		OutputDebugString("DMUS_E_TYPE_UNSUPPORTED\n");
		break;
	case DMUS_E_UNKNOWNDOWNLOAD:
		OutputDebugString("DMUS_E_UNKNOWNDOWNLOAD\n");
		break;
	case DMUS_E_UNKNOWN_PROPERTY:
		OutputDebugString("DMUS_E_UNKNOWN_PROPERTY\n");
		break;
	case DMUS_E_UNSUPPORTED_STREAM:
		OutputDebugString("DMUS_E_UNSUPPORTED_STREAM\n");
		break;
	case DMUS_E_WAVEFORMATNOTSUPPORTED:
		OutputDebugString("DMUS_E_WAVEFORMATNOTSUPPORTED\n");
		break;
	case DMUS_S_DOWN_OCTAVE:
		OutputDebugString("DMUS_S_DOWN_OCTAVE\n");
		break;
	case DMUS_S_END:
		OutputDebugString("DMUS_S_END\n");
		break;
	case DMUS_S_FREE:
		OutputDebugString("DMUS_S_FREE\n");
		break;
	case DMUS_S_LAST_TOOL:
		OutputDebugString("DMUS_S_LAST_TOOL\n");
		break;
	case DMUS_S_NOBUFFERCONTROL:
		OutputDebugString("DMUS_S_NOBUFFERCONTROL\n");
		break;
	case DMUS_S_OVER_CHORD:
		OutputDebugString("DMUS_S_OVER_CHORD\n");
		break;
	case DMUS_S_PARTIALDOWNLOAD:
		OutputDebugString("DMUS_S_PARTIALDOWNLOAD\n");
		break;
	case DMUS_S_PARTIALLOAD:
		OutputDebugString("DMUS_S_PARTIALLOAD\n");
		break;
	case DMUS_S_REQUEUE:
		OutputDebugString("DMUS_S_REQUEUE\n");
		break;
	case DMUS_S_STRING_TRUNCATED:
		OutputDebugString("DMUS_S_STRING_TRUNCATED\n");
		break;
	case DMUS_S_UP_OCTAVE:
		OutputDebugString("DMUS_S_UP_OCTAVE\n");
		break;
	case E_FAIL:
		OutputDebugString("E_FAIL\n");
		break;
	case E_INVALIDARG:
		OutputDebugString("E_INVALIDARG\n");
		break;
//	case E_NOAGGREGATION:
//		OutputDebugString("E_NOAGGREGATION\n");
//		break;
	case E_NOINTERFACE:
		OutputDebugString("E_NOINTERFACE\n");
		break;
	case E_NOTIMPL:
		OutputDebugString("E_NOTIMPL\n");
		break;
	case E_OUTOFMEMORY:
		OutputDebugString("E_OUTOFMEMORY\n");
		break;
	case E_POINTER:
		OutputDebugString("E_POINTER\n");
		break;
	case REGDB_E_CLASSNOTREG:
		OutputDebugString("REGDB_E_CLASSNOTREG\n");
		break;
	default:
		OutputDebugString("Unknown DirectMusic Error\n");
		break;
	}
}

void Debugger::printErrorDXFile(HRESULT value)
{
	switch (value)
	{
	case DXFILE_OK:
		OutputDebugString("DXFILE_OK\n");
		break;
	case DXFILEERR_BADALLOC:
		OutputDebugString("DXFILEERR_BADALLOC\n");
		break;
	case DXFILEERR_BADARRAYSIZE:
		OutputDebugString("DXFILEERR_BADARRAYSIZE\n");
		break;
	case DXFILEERR_BADCACHEFILE:
		OutputDebugString("DXFILEERR_BADCACHEFILE\n");
		break;
	case DXFILEERR_BADDATAREFERENCE:
		OutputDebugString("DXFILEERR_BADDATAREFERENCE\n");
		break;
	case DXFILEERR_BADFILE:
		OutputDebugString("DXFILEERR_BADFILE\n");
		break;
	case DXFILEERR_BADFILEFLOATSIZE:
		OutputDebugString("DXFILEERR_BADFILEFLOATSIZE\n");
		break;
	case DXFILEERR_BADFILETYPE:
		OutputDebugString("DXFILEERR_BADFILETYPE\n");
		break;
	case DXFILEERR_BADFILEVERSION:
		OutputDebugString("DXFILEERR_BADFILEVERSION\n");
		break;
	case DXFILEERR_BADRESOURCE:
		OutputDebugString("DXFILEERR_BADRESOURCE\n");
		break;
	case DXFILEERR_BADTYPE:
		OutputDebugString("DXFILEERR_BADTYPE\n");
		break;
	case DXFILEERR_BADVALUE:
		OutputDebugString("DXFILEERR_BADVALUE\n");
		break;
	case DXFILEERR_FILENOTFOUND:
		OutputDebugString("DXFILEERR_FILENOTFOUND\n");
		break;
	case DXFILEERR_NOMOREDATA:
		OutputDebugString("DXFILEERR_NOMOREDATA\n");
		break;
	case DXFILEERR_NOMOREOBJECTS:
		OutputDebugString("DXFILEERR_NOMOREOBJECTS\n");
		break;
	case DXFILEERR_NOTFOUND:
		OutputDebugString("DXFILEERR_NOTFOUND\n");
		break;
	case DXFILEERR_PARSEERROR:
		OutputDebugString("DXFILEERR_PARSEERROR\n");
		break;
	case DXFILEERR_RESOURCENOTFOUND:
		OutputDebugString("DXFILEERR_RESOURCENOTFOUND\n");
		break;
	case DXFILEERR_URLNOTFOUND:
		OutputDebugString("DXFILEERR_URLNOTFOUND\n");
		break;
	default:
		OutputDebugString("Unknown DirectXFile Error\n");
		break;
	}
}
