/*   NX  Ver 0.20   */
/*                            */
/*                            */
/*   by Atsushi   1999/8/13   */


#include "basic.h"

#include <stdio.h>
#include <string.h>
#include <stdarg.h>


/*   ---   RXgN^   ---   */

String::String(char* string)
{
	this->string=string;
	
	mustDelete=FALSE;
}

String::String(char* string,boolean mustDelete)
{
	this->string    =string;
	this->mustDelete=mustDelete;
}

String::String(String* string)
{
	if (string->mustDelete)
	{
		this->string=new char[strlen(string->string)+1];
		strcpy(this->string,string->string);
		
		mustDelete=TRUE;
	}
	else
	{
		this->string=string->string;
		
		mustDelete=FALSE;
	}
}


/*   ---      ---   */

int String::length(void)
{
	return strlen(string);
}

char* String::toCharArray(void)
{
	return string;
}

char String::charAt(int index)
{
	return string[index];
}


/*   ---   r   ---   */

boolean String::equals(String* target)
{
	return (strcmp(string,target->string)==0);
}

boolean String::equals(char* target)
{
	return (strcmp(string,target)==0);
}

boolean String::equalsIgnoreCase(String* target)
{
	return (_stricmp(string,target->string)==0);
}

boolean String::equalsIgnoreCase(char* target)
{
	return (_stricmp(string,target)==0);
}

boolean String::startsWith(String* target)
{
	return (strncmp(string,target->string,strlen(target->string))==0);
}

boolean String::startsWith(char* target)
{
	return (strncmp(string,target,strlen(target))==0);
}

boolean String::endsWith(String* target)
{
	return (strncmp(string+strlen(string)-strlen(target->string),
	                target->string,strlen(target->string))==0);
}

boolean String::endsWith(char* target)
{
	return (strncmp(string+strlen(string)-strlen(target),
	                target,strlen(target))==0);
}


/*   ---   ǉ   ---   */

String* String::concat(String* addend)
{
	char* newString;

	newString=new char[strlen(string)+strlen(addend->string)+1];
	strcpy(newString,string);
	strcat(newString,addend->string);
	
	return new String(newString,TRUE);
}

String* String::operator+(String addend)
{
	return concat(&addend);
}


/*   ---   ؂o   ---   */

String* String::substring(int begin,int end)
{
	char* newString;

	begin=max(begin,0             );
	end  =min(end  ,strlen(string));
	
	if (begin>=end) return new String("");
	
	newString=new char[end-begin+1];
	strncpy(newString,&(string[begin]),end-begin);
	newString[end-begin]=NULL;
	
	return new String(newString,TRUE);
}


/*   ---      ---   */

int String::indexOf(char c)
{
	char* result;

	result=strchr(string,c);
	
	return (result==NULL ? -1 : result-string);
}

int String::lastIndexOf(char c)
{
	char* result;

	result=strrchr(string,c);
	
	return (result==NULL ? -1 : result-string);
}


/*   ---   ؂l   ---   */

String* String::trim(void)
{
	int left,right;
	int len;

	len=length();
	
	left=0;right=len-1;
	
	while (string[left ]==' ' && left <=len-2) left ++;
	while (string[right]==' ' && right>=    1) right--;
	
	return substring(left,right+1);
}


/*   ---   l   ---   */

int String::toInteger(void)
{
	return atoi(string);
}

double String::toDouble(void)
{
	return atof(string);
}


/*   ---      ---   */

String* String::valueOf(int value)
{
	char* buffer;

	buffer=new char[33];
	_itoa(value,buffer,10);
	
	return new String(buffer,TRUE);
}

String* String::valueOf(double value)
{
	char* buffer;

	buffer=new char[13];
	_gcvt(value,12,buffer);
	
	return new String(buffer,TRUE);
}


/*   ---   tH[}bg   ---   */

String* String::format(char* format,...)
{
	char* buffer;
	va_list args;

	buffer=new char[300];
	va_start(args,format);
	vsprintf(buffer,format,args);
	
	return new String(buffer,TRUE);
}


/*   ---   nbVR[h   ---   */

int String::getHashCode(void)
{
	int hash,offset;
	int skip,len;

	hash=0;
	offset=0;
	len=length();
	
	if (len<16)
	{
		for (int i=len;i>0;i--)
		{
			hash=(hash*37)+string[offset++];
		}
	}
	else
	{
		skip=len/8;
		for (int i=len;i>0;i-=skip,offset+=skip)
		{
			hash=(hash*39)+string[offset];
		}
	}
	
	return hash;
}


/*   ---   fXgN^   ---   */

String::~String(void)
{
	if (mustDelete) delete[] string;
}
