/*   NH[^jI  Ver 0.20   */
/*                              */
/*                              */
/*   by Atsushi    1999/10/21   */


class Vector3;
class Matrix4;


class Quaternion:public Object
{
private:
	D3DXQUATERNION quaternion;

public:
	Quaternion(float w,float x,float y,float z);
	Quaternion(Quaternion* quaternion);
	Quaternion(void);
	~Quaternion(void);
	
	static void* operator new(size_t size);
	static void operator delete(void *object);
	
	virtual D3DXQUATERNION* getDXQuaternion(void);
	virtual float getX(void);
	virtual float getY(void);
	virtual float getZ(void);
	virtual float getW(void);
	
	virtual boolean isIdentity(void);
	
	virtual void set(Quaternion* quaternion);
	virtual void set(float w,float x,float y,float z);
	virtual void setZero(void);
	virtual void setIdentity(void);
	
	virtual void setRotation(Vector3* axis,double angle);
	virtual void setRotation(Matrix4* matrix);
	
	virtual void setAddition(Quaternion* value,Quaternion* addend);
	virtual void setSubtraction(Quaternion* value0,Quaternion* value1);
	virtual void setMultiplication(Quaternion* multiplicand,
	                               Quaternion* multiplier);
	virtual void setMultiplication(float multiplier);
	virtual void setConjugate(Quaternion* value);
	virtual void setInverse(Quaternion* value);
	virtual void setSlerp(Quaternion* value0,Quaternion* value1,double alpha);
	virtual void setNormalize(void);
	
	virtual float getLength(void);
	virtual float getLength2(void);
	
	virtual Quaternion* add(Quaternion* addend);
	virtual Quaternion* operator+(Quaternion addend);
	
	virtual Quaternion* subtract(Quaternion* value1);
	virtual Quaternion* operator-(Quaternion value1);
	
	virtual Quaternion* multiply(Quaternion* multiplier);
	virtual Quaternion* operator*(Quaternion multiplier);
	virtual Quaternion* multiply(float multiplier);
	virtual Quaternion* operator*(float multiplier);
	
	virtual Quaternion* conjugate(void);
	
	virtual float dot(Quaternion* multiplier);
	
	virtual Quaternion* inverse(void);
	
	virtual Quaternion* slerp(Quaternion* value1,double alpha);
	
	virtual Quaternion* normalize(void);
};
