/*   ϊs      Ver 0.40   */
/*                            */
/*                            */
/*   by Atsushi  1999/10/21   */


#include "basic.h"

#include "lib/util/OutOfPoolException.h"
#include "lib/util/PooledObject.h"
#include "lib/util/ObjectPool.h"
#include "Vector3.h"
#include "Vector4.h"
#include "Quaternion.h"
#include "Matrix4.h"
#include "IllegalOperatorException.h"
#include "TransformMatrix.h"
#include "RotationMatrix.h"


/*   ---   RXgN^   ---   */

RotationMatrix::RotationMatrix(D3DMATRIX matrix) :TransformMatrix(matrix)
{
}

RotationMatrix::RotationMatrix(RotationMatrix* matrix) :TransformMatrix(matrix)
{
}

RotationMatrix::RotationMatrix(void) :TransformMatrix()
{
}


/*   ---   v[   ---   */

void* RotationMatrix::operator new(size_t size)
{
	return ObjectPool<TransformMatrix>::newObject();
}

void RotationMatrix::operator delete(void *object)
{
	ObjectPool<TransformMatrix>::deleteObject((RotationMatrix*)(object));
}


/*   ---   ړ   ---   */

void RotationMatrix::setTranslation(D3DVALUE vx,D3DVALUE vy,D3DVALUE vz)
{
	throw new IllegalOperatorException(new String(
	    "RotationMatrix::setTranslation"));
}

void RotationMatrix::setTranslation(Vector3* delta)
{
	throw new IllegalOperatorException(new String(
	    "RotationMatrix::setTranslation"));
}


/*   ---   XP[   ---   */

void RotationMatrix::setScale(D3DVALUE scale)
{
	throw new IllegalOperatorException(new String(
	    "RotationMatrix::setScale"));
}

void RotationMatrix::setScale(D3DVALUE x,D3DVALUE y,D3DVALUE z)
{
	throw new IllegalOperatorException(new String(
	    "RotationMatrix::setScale"));
}

void RotationMatrix::setScaleMultiplication(D3DVALUE scale)
{
	throw new IllegalOperatorException(new String(
	    "RotationMatrix::setScaleMultiplication"));
}

void RotationMatrix::setScaleMultiplication(D3DVALUE x,D3DVALUE y,D3DVALUE z)
{
	throw new IllegalOperatorException(new String(
	    "RotationMatrix::setScaleMultiplication"));
}


/*   ---   Be   ---   */

void RotationMatrix::setLookAt(Vector3* position,Vector3* target,Vector3* up)
{
	throw new IllegalOperatorException(new String(
	    "RotationMatrix::setLookAt"));
}


/*   ---   eݒ   ---   */

void RotationMatrix::setFrustumProjection(double nearClip,double farClip,
                                           double hFOV,double vFOV)
{
	throw new IllegalOperatorException(new String(
	    "RotationMatrix::setFrustumProjection"));
}

void RotationMatrix::setParallelProjection(double nearClip,double farClip,
                                            double width,double height)
{
	throw new IllegalOperatorException(new String(
	    "RotationMatrix::setParallelProjection"));
}


/*   ---   ݒ   ---   */

void RotationMatrix::set(Matrix4* matrix)
{
	throw new IllegalOperatorException(new String(
	    "RotationMatrix::set"));
}

void RotationMatrix::set(RotationMatrix* matrix)
{
	Matrix4::set(matrix);
}

void RotationMatrix::set(int y,int x,float value)
{
	throw new IllegalOperatorException(new String(
	    "RotationMatrix::set"));
}


/*   ---   ώZ   ---   */

void RotationMatrix::setMultiplication(TransformMatrix* multiplicand,
                                       TransformMatrix* multiplier)
{
	throw new IllegalOperatorException(new String(
	    "RotationMatrix::setMultiplication"));
}

void RotationMatrix::setMultiplication(RotationMatrix* multiplicand,
                                       RotationMatrix* multiplier)
{
	TransformMatrix::setMultiplication(multiplicand,multiplier);
}

void RotationMatrix::setMultiplication(TranslationMatrix* multiplicand,
                                       TranslationMatrix* multiplier)
{
	throw new IllegalOperatorException(new String(
	    "RotationMatrix::setMultiplication"));
}

void RotationMatrix::setMultiplication(TranslationMatrix* multiplicand,
                                       RotationMatrix* multiplier)
{
	throw new IllegalOperatorException(new String(
	    "RotationMatrix::setMultiplication"));
}

void RotationMatrix::setMultiplication(RotationMatrix* multiplicand,
                                       TranslationMatrix* multiplier)
{
	throw new IllegalOperatorException(new String(
	    "RotationMatrix::setMultiplication"));
}

RotationMatrix* RotationMatrix::multiply(RotationMatrix* multiplier)
{
	RotationMatrix* answer;

	answer=new RotationMatrix();
	answer->setMultiplication(this,multiplier);
	
	return answer;
}

RotationMatrix* RotationMatrix::operator*(RotationMatrix multiplier)
{
	return multiply(&multiplier);
}


/*   ---   fXgN^   ---   */

RotationMatrix::~RotationMatrix(void)
{
}
