/*   ϊs      Ver 0.40   */
/*                            */
/*                            */
/*   by Atsushi  1999/10/21   */


class Vector3;
class Vector4;
class Quaternion;
class TransformMatrix;


class RotationMatrix:public TransformMatrix
{
public:
	RotationMatrix(D3DMATRIX matrix);
	RotationMatrix(RotationMatrix* matrix);
	RotationMatrix(void);
	~RotationMatrix(void);
	
	static void* operator new(size_t size);
	static void operator delete(void *object);
	
	virtual void setTranslation(D3DVALUE vx,D3DVALUE vy,D3DVALUE vz);
	virtual void setTranslation(Vector3* delta);
	virtual void setScale(D3DVALUE scale);
	virtual void setScale(D3DVALUE x,D3DVALUE y,D3DVALUE z);
	
	virtual void setLookAt(Vector3* position,Vector3* target,Vector3* up);
	virtual void setFrustumProjection(double nearClip,double farClip,
	                                  double hFOV,double vFOV);
	virtual void setParallelProjection(double nearClip,double farClip,
	                                   double width,double height);
	
	virtual void set(Matrix4* matrix);
	virtual void set(RotationMatrix* matrix);
	virtual void set(int y,int x,float value);
	virtual void setMultiplication(TransformMatrix* multiplicand,
	                               TransformMatrix* multiplier);
	virtual void setMultiplication(RotationMatrix* multiplicand,
	                               RotationMatrix* multiplier);
	virtual void setMultiplication(TranslationMatrix* multiplicand,
	                               TranslationMatrix* multiplier);
	virtual void setMultiplication(TranslationMatrix* multiplicand,
	                               RotationMatrix* multiplier);
	virtual void setMultiplication(RotationMatrix* multiplicand,
	                               TranslationMatrix* multiplier);
	
	virtual RotationMatrix* multiply(RotationMatrix* multiplier);
	virtual RotationMatrix* operator*(RotationMatrix multiplier);
	
	virtual void setScaleMultiplication(D3DVALUE scale);
	virtual void setScaleMultiplication(D3DVALUE x,D3DVALUE y,D3DVALUE z);
};
