/*   ϊs      Ver 0.40   */
/*                            */
/*                            */
/*   by Atsushi  1999/10/21   */


class Vector3;
class Vector4;
class Quaternion;
class RotationMatrix;
class TranslationMatrix;


class TransformMatrix:public Matrix4
{
public:
	TransformMatrix(D3DMATRIX matrix);
	TransformMatrix(TransformMatrix* matrix);
	TransformMatrix(void);
	~TransformMatrix(void);
	
	static void* operator new(size_t size);
	static void operator delete(void *object);
	
	virtual void setTranslation(float vx,float vy,float vz);
	virtual void setTranslation(Vector3* delta);
	virtual void setRotationX(double angle);
	virtual void setRotationY(double angle);
	virtual void setRotationZ(double angle);
	virtual void setRotation(Vector3* i,Vector3* j,Vector3* k);
	virtual void setRotation(Vector3* axis,double angle);
	virtual void setRotation(Quaternion* rotation);
	virtual void setRotationInverse(Vector3* i,Vector3* j,Vector3* k);
	virtual void setRotationInverse(TransformMatrix* rotation);
	virtual void setScale(float scale);
	virtual void setScale(float x,float y,float z);
	
	virtual void setLookAt(Vector3* position,Vector3* target,Vector3* up);
	
	virtual void setFrustumProjection(double nearClip,double farClip,
	                                  double hFOV,double vFOV);
	virtual void setParallelProjection(double nearClip,double farClip,
	                                   double width,double height);
	
	virtual void setNormalizeRotation(void);
	
	virtual Vector3* transform(Vector3* vector);
	virtual Vector4* transform(Vector4* vector);
	
	virtual TransformMatrix* multiply(TransformMatrix* multiplier);
	virtual TransformMatrix* operator*(TransformMatrix multiplier);
	
	virtual void setMultiplication(TransformMatrix* multiplicand,
	                               TransformMatrix* multiplier);
	
	virtual void setScaleMultiplication(float scale);
	virtual void setScaleMultiplication(float x,float y,float z);
};
