/*   ϊs      Ver 0.40   */
/*                            */
/*                            */
/*   by Atsushi  1999/10/21   */


#include "basic.h"

#include "lib/util/OutOfPoolException.h"
#include "lib/util/PooledObject.h"
#include "lib/util/ObjectPool.h"
#include "Vector3.h"
#include "Vector4.h"
#include "Quaternion.h"
#include "Matrix4.h"
#include "IllegalOperatorException.h"
#include "TransformMatrix.h"
#include "TranslationMatrix.h"


/*   ---   RXgN^   ---   */

TranslationMatrix::TranslationMatrix(D3DMATRIX matrix)
                  :TransformMatrix(matrix)
{
}

TranslationMatrix::TranslationMatrix(TranslationMatrix* matrix)
                  :TransformMatrix(matrix)
{
}

TranslationMatrix::TranslationMatrix(void) :TransformMatrix()
{
}


/*   ---   v[   ---   */

void* TranslationMatrix::operator new(size_t size)
{
	return ObjectPool<TransformMatrix>::newObject();
}

void TranslationMatrix::operator delete(void *object)
{
	ObjectPool<TransformMatrix>::deleteObject((TranslationMatrix*)(object));
}


/*   ---   ]   ---   */

void TranslationMatrix::setRotationX(double angle)
{
	throw new IllegalOperatorException(new String(
	    "TranslationMatrix::setRotationX"));
}

void TranslationMatrix::setRotationY(double angle)
{
	throw new IllegalOperatorException(new String(
	    "TranslationMatrix::setRotationY"));
}

void TranslationMatrix::setRotationZ(double angle)
{
	throw new IllegalOperatorException(new String(
	    "TranslationMatrix::setRotationZ"));
}

void TranslationMatrix::setRotation(Vector3* i,Vector3* j,Vector3* k)
{
	throw new IllegalOperatorException(new String(
	    "TranslationMatrix::setRotation"));
}

void TranslationMatrix::setRotation(Vector3* axis,double angle)
{
	throw new IllegalOperatorException(new String(
	    "TranslationMatrix::setRotation"));
}

void TranslationMatrix::setRotation(Quaternion* rotation)
{
	throw new IllegalOperatorException(new String(
	    "TranslationMatrix::setRotation"));
}

void TranslationMatrix::setRotationInverse(Vector3* i,Vector3* j,Vector3* k)
{
	throw new IllegalOperatorException(new String(
	    "TranslationMatrix::setRotationInverse"));
}

void TranslationMatrix::setRotationInverse(TranslationMatrix* rotation)
{
	throw new IllegalOperatorException(new String(
	    "TranslationMatrix::setRotationInverse"));
}


/*   ---   XP[   ---   */

void TranslationMatrix::setScale(D3DVALUE scale)
{
	throw new IllegalOperatorException(new String(
	    "TranslationMatrix::setScale"));
}

void TranslationMatrix::setScale(D3DVALUE x,D3DVALUE y,D3DVALUE z)
{
	throw new IllegalOperatorException(new String(
	    "TranslationMatrix::setScale"));
}

void TranslationMatrix::setScaleMultiplication(D3DVALUE scale)
{
	throw new IllegalOperatorException(new String(
	    "TranslationMatrix::setScaleMultiplication"));
}

void TranslationMatrix::setScaleMultiplication(
    D3DVALUE x,D3DVALUE y,D3DVALUE z)
{
	throw new IllegalOperatorException(new String(
	    "TranslationMatrix::setScaleMultiplication"));
}


/*   ---   Be   ---   */

void TranslationMatrix::setLookAt(Vector3* position,Vector3* target,
                                  Vector3* up)
{
	throw new IllegalOperatorException(new String(
	    "TranslationMatrix::setLookAt"));
}


/*   ---   eݒ   ---   */

void TranslationMatrix::setFrustumProjection(double nearClip,double farClip,
                                             double hFOV,double vFOV)
{
	throw new IllegalOperatorException(new String(
	    "TranslationMatrix::setFrustumProjection"));
}

void TranslationMatrix::setParallelProjection(double nearClip,double farClip,
                                              double width,double height)
{
	throw new IllegalOperatorException(new String(
	    "TranslationMatrix::setParallelProjection"));
}


/*   ---   K   ---   */

void TranslationMatrix::setNormalizeRotation(void)
{
	throw new IllegalOperatorException(new String(
	    "TranslationMatrix::setNormalizeRotation"));
}


/*   ---   ݒ   ---   */

void TranslationMatrix::set(Matrix4* matrix)
{
	throw new IllegalOperatorException(new String(
	    "TranslationMatrix::set"));
}

void TranslationMatrix::set(TranslationMatrix* matrix)
{
	Matrix4::set(matrix);
}

void TranslationMatrix::set(int y,int x,float value)
{
	throw new IllegalOperatorException(new String(
	    "TranslationMatrix::set"));
}


/*   ---   ώZ   ---   */

void TranslationMatrix::setMultiplication(TransformMatrix* multiplicand,
                                          TransformMatrix* multiplier)
{
	throw new IllegalOperatorException(new String(
	    "TransformMatrix::setMultiplication"));
}

void TranslationMatrix::setMultiplication(TranslationMatrix* multiplicand,
                                          TranslationMatrix* multiplier)
{
	TransformMatrix::setMultiplication(multiplicand,multiplier);
}

void TranslationMatrix::setMultiplication(RotationMatrix* multiplicand,
                                          RotationMatrix* multiplier)
{
	throw new IllegalOperatorException(new String(
	    "TransformMatrix::setMultiplication"));
}

void TranslationMatrix::setMultiplication(TranslationMatrix* multiplicand,
                                          RotationMatrix* multiplier)
{
	throw new IllegalOperatorException(new String(
	    "TransformMatrix::setMultiplication"));
}

void TranslationMatrix::setMultiplication(RotationMatrix* multiplicand,
                                          TranslationMatrix* multiplier)
{
	throw new IllegalOperatorException(new String(
	    "TransformMatrix::setMultiplication"));
}

TranslationMatrix* TranslationMatrix::multiply(TranslationMatrix* multiplier)
{
	TranslationMatrix* answer;

	answer=new TranslationMatrix();
	answer->setMultiplication(this,multiplier);
	
	return answer;
}

TranslationMatrix* TranslationMatrix::operator*(TranslationMatrix multiplier)
{
	return multiply(&multiplier);
}


/*   ---   fXgN^   ---   */

TranslationMatrix::~TranslationMatrix(void)
{
}
