/*   ϊs      Ver 0.40   */
/*                            */
/*                            */
/*   by Atsushi  1999/10/21   */


class Vector3;
class Vector4;
class Quaternion;
class RotationMatrix;
class TransformMatrix;


class TranslationMatrix:public TransformMatrix
{
public:
	TranslationMatrix(D3DMATRIX matrix);
	TranslationMatrix(TranslationMatrix* matrix);
	TranslationMatrix(void);
	~TranslationMatrix(void);
	
	static void* operator new(size_t size);
	static void operator delete(void *object);
	
	virtual void setRotationX(double angle);
	virtual void setRotationY(double angle);
	virtual void setRotationZ(double angle);
	virtual void setRotation(Vector3* i,Vector3* j,Vector3* k);
	virtual void setRotation(Vector3* axis,double angle);
	virtual void setRotation(Quaternion* rotation);
	virtual void setRotationInverse(Vector3* i,Vector3* j,Vector3* k);
	virtual void setRotationInverse(TranslationMatrix* rotation);
	virtual void setScale(D3DVALUE scale);
	virtual void setScale(D3DVALUE x,D3DVALUE y,D3DVALUE z);
	
	virtual void setLookAt(Vector3* position,Vector3* target,Vector3* up);
	virtual void setFrustumProjection(double nearClip,double farClip,
	                                  double hFOV,double vFOV);
	virtual void setParallelProjection(double nearClip,double farClip,
	                                   double width,double height);
	
	virtual void setNormalizeRotation(void);
	
	virtual void set(Matrix4* matrix);
	virtual void set(TranslationMatrix* matrix);
	virtual void set(int y,int x,float value);
	virtual void setMultiplication(TransformMatrix* multiplicand,
	                               TransformMatrix* multiplier);
	virtual void setMultiplication(RotationMatrix* multiplicand,
	                               RotationMatrix* multiplier);
	virtual void setMultiplication(TranslationMatrix* multiplicand,
	                               TranslationMatrix* multiplier);
	virtual void setMultiplication(TranslationMatrix* multiplicand,
	                               RotationMatrix* multiplier);
	virtual void setMultiplication(RotationMatrix* multiplicand,
	                               TranslationMatrix* multiplier);
	
	virtual TranslationMatrix* multiply(TranslationMatrix* multiplier);
	virtual TranslationMatrix* operator*(TranslationMatrix multiplier);
	
	virtual void setScaleMultiplication(D3DVALUE scale);
	virtual void setScaleMultiplication(D3DVALUE x,D3DVALUE y,D3DVALUE z);
};
