/*   3 xNg  Ver 0.60   */
/*                              */
/*                              */
/*   by Atsushi    1999/12/20   */


class Vector3:public Object
{
private:
	D3DXVECTOR3 vector;

public:
	Vector3(D3DVECTOR vector);
	Vector3(float x,float y,float z);
	Vector3(Vector3* vector);
	Vector3(void);
	~Vector3(void);
	
	static void* operator new(size_t size);
	static void operator delete(void *object);
	
	virtual D3DVECTOR* getVector(void);
	virtual D3DXVECTOR3* getDXVector(void);
	virtual float getX(void);
	virtual float getY(void);
	virtual float getZ(void);
	virtual boolean isZero(void);
	
	virtual void set(Vector3* vector);
	virtual void set(float x,float y,float z);
	virtual void setZero(void);
	
	virtual void setAddition(Vector3* value,Vector3* addend);
	virtual void setSubtraction(Vector3* value0,Vector3* value1);
	virtual void setCrossProduct(Vector3* multiplicand,Vector3* multiplier);
	virtual void setMultiplication(float multiplier);
	virtual void setNormalize(void);
	virtual void setInterpolation(Vector3* v1,Vector3* v2,double blend);
	virtual void setBaryCentric(Vector3* v1,Vector3* v2,Vector3* v3,
	                            float weight2,float weight3);
	
	virtual float getLength(void);
	virtual float getLength2(void);
	virtual double getAngle(Vector3* target);
	
	virtual Vector3* add(Vector3* addend);
	virtual Vector3* operator+(Vector3 addend);
	
	virtual Vector3* subtract(Vector3* value1);
	virtual Vector3* operator-(Vector3 value1);
	
	virtual float dot(Vector3* multiplier);
	virtual Vector3* cross(Vector3* multiplier);
	
	virtual Vector3* multiply(float multiplier);
	virtual Vector3* operator*(float multiplier);
	
	virtual Vector3* normalize(void);
};
