/*   4 xNg  Ver 0.20   */
/*                              */
/*                              */
/*   by Atsushi    1999/12/20   */


class Vector4:public Object
{
private:
	D3DXVECTOR4 vector;

public:
	Vector4(float x,float y,float z);
	Vector4(float x,float y,float z,float w);
	Vector4(Vector4* vector);
	Vector4(Vector3* vector);
	Vector4(void);
	~Vector4(void);
	
	static void* operator new(size_t size);
	static void operator delete(void *object);
	
	virtual D3DXVECTOR4* getDXVector(void);
	virtual float getX(void);
	virtual float getY(void);
	virtual float getZ(void);
	virtual float getW(void);
	virtual boolean isZero(void);
	
	virtual void set(Vector4* vector);
	virtual void set(float x,float y,float z);
	virtual void setZero(void);
	
	virtual void setAddition(Vector4* value,Vector4* addend);
	virtual void setSubtraction(Vector4* value0,Vector4* value1);
	virtual void setCrossProduct(Vector4* multiplicand,
	                             Vector4* multiplier1,Vector4* multiplier2);
	virtual void setMultiplication(float multiplier);
	virtual void setNormalize(void);
	virtual void setInterpolation(Vector4* v1,Vector4* v2,double blend);
	virtual void setBaryCentric(Vector4* v1,Vector4* v2,Vector4* v3,
	                            float weight2,float weight3);
	
	virtual float getLength(void);
	virtual float getLength2(void);
	virtual double getAngle(Vector4* target);
	
	virtual Vector4* add(Vector4* addend);
	virtual Vector4* operator+(Vector4 addend);
	
	virtual Vector4* subtract(Vector4* value1);
	virtual Vector4* operator-(Vector4 value1);
	
	virtual float dot(Vector4* multiplier);
	
	virtual Vector4* multiply(float multiplier);
	virtual Vector4* operator*(float multiplier);
	
	virtual Vector4* normalize(void);
};
