/*   InetAddress NX  Ver 0.10   */
/*                                  */
/*                                  */
/*   by toyo    1999/4/29           */

#include "basic.h"
#include "NetworkException.h"
#include "InetAddress.h"

InetAddress::InetAddress(LPSOCKADDR_IN lpSocketAddress){
	this->lpSocketAddress=lpSocketAddress;
	this->hostName=NULL;
}

InetAddress::InetAddress(LPSOCKADDR_IN lpSocketAddress,String *hostName){
	this->lpSocketAddress=lpSocketAddress;
	this->hostName=hostName;
}

InetAddress::~InetAddress(void){
	delete lpSocketAddress;
	delete hostName;
}

//public member function

InetAddress* InetAddress::clone(void){
	LPSOCKADDR_IN lpSocketAddress;
	String *hostName;
	
	lpSocketAddress=(LPSOCKADDR_IN)malloc(sizeof(SOCKADDR_IN));
	memmove(lpSocketAddress,this->lpSocketAddress,sizeof(SOCKADDR_IN));
	
	int charLength=this->hostName->length();
	char *charArray=new char[charLength+1];
	memmove(charArray,this->hostName->toCharArray(),charLength);
	charArray[charLength]=NULL;
	
	hostName=new String(charArray);
	
	return new InetAddress(lpSocketAddress,hostName);
}

BYTE* InetAddress::getAddress(void){
	return (BYTE *)&lpSocketAddress->sin_addr;
}

String* InetAddress::getHostAddress(void){
	return new String(inet_ntoa(lpSocketAddress->sin_addr)); 
}

String* InetAddress::getHostName(void) throw (NetworkException*){
	if(hostName!=NULL){
		return hostName;
	}else{
		LPHOSTENT lpHostEntry;
		//ubN܂B
		lpHostEntry=gethostbyaddr(
			(char *)&lpSocketAddress->sin_addr,
			sizeof(IN_ADDR),
			AF_INET
		);
		
		if(lpHostEntry==NULL){
			//O𓊂
			return NULL;
		}
		
		char *h_name;
		
		h_name=(char *)malloc(sizeof(char)*strlen(lpHostEntry->h_name));
		strcpy(h_name,lpHostEntry->h_name);
		this->hostName=new String(h_name);
		return hostName;
	}
}

//static member function

InetAddress* InetAddress::getByName(String *name) throw (NetworkException*){
	IN_ADDR internetAddress;
	LPHOSTENT lpHostEntry;
	
	internetAddress.s_addr=inet_addr(name->toCharArray());
	
	if(internetAddress.s_addr==INADDR_NONE){
		//ubN
		lpHostEntry=gethostbyname(name->toCharArray());
	}else{
		//ubN
		lpHostEntry=gethostbyaddr(
			(const char *)&internetAddress,
			sizeof(IN_ADDR),
			AF_INET
		);
	}
	
	if(lpHostEntry==NULL){
		//O𓊂B
		return NULL;
	}
	
	String *hostName;
	char *h_name;

	h_name=(char *)malloc(sizeof(char)*strlen(lpHostEntry->h_name));
	strcpy(h_name,lpHostEntry->h_name);
	hostName=new String(h_name);
	
	LPSOCKADDR_IN lpSocketAddress=(LPSOCKADDR_IN)malloc(sizeof(SOCKADDR_IN));
		
	memset(lpSocketAddress,0,sizeof(SOCKADDR_IN));
	lpSocketAddress->sin_family=AF_INET;
	
	memmove(
		&lpSocketAddress->sin_addr.s_addr,
		*lpHostEntry->h_addr_list,
		sizeof(BYTE)*4
	);
	
	return new InetAddress(lpSocketAddress,hostName);
}



InetAddress** InetAddress::getAllByName(String *name) throw (NetworkException*){
	/*
	if(strcmp(name->toCharArray(),"127.0.0.1")==0 ||
		strcmp(name->toCharArray(),"localhost")==0){
		char hostname[64];
		gethostname(hostname,64);
		name=new String(hostname);
	}
	*/
	
	IN_ADDR internetAddress;
	LPHOSTENT lpHostEntry;
	
	internetAddress.s_addr=inet_addr(name->toCharArray());
	
	if(internetAddress.s_addr==INADDR_NONE){
		//ubN
		lpHostEntry=gethostbyname(name->toCharArray());
	}else{
		//ubN
		lpHostEntry=gethostbyaddr(
			(const char *)&internetAddress,
			sizeof(IN_ADDR),
			AF_INET
		);
	}
	
	if(lpHostEntry==NULL){
		//O𓊂B
		return NULL;
	}
	

	InetAddress **inetAddress;
	String *hostName;
	char *h_name;

	int addressNum=0;
	for(;;addressNum++){
		if(*(lpHostEntry->h_addr_list+addressNum)==NULL)break;
	}
	
	inetAddress=new InetAddress*[addressNum];
	
	h_name=(char *)malloc(sizeof(char)*strlen(lpHostEntry->h_name));
	strcpy(h_name,lpHostEntry->h_name);
	hostName=new String(h_name);
	
	for(int i=0;i<addressNum;i++){
		LPSOCKADDR_IN lpSocketAddress=(LPSOCKADDR_IN)malloc(sizeof(SOCKADDR_IN));
		
		memset(lpSocketAddress,0,sizeof(SOCKADDR_IN));
		lpSocketAddress->sin_family=AF_INET;
		
		memmove(
			&lpSocketAddress->sin_addr.s_addr,
			*(lpHostEntry->h_addr_list+i),
			sizeof(BYTE)*4
		);
		
		inetAddress[i]=new InetAddress(lpSocketAddress,hostName);
		
	}
	
	inetAddress[addressNum]=NULL;
	return inetAddress;
}

InetAddress* InetAddress::getLocalHost() throw (NetworkException*){
	char *hostname=new char[64];
	gethostname(hostname,64);
	InetAddress **inetAddress=getAllByName(new String(hostname));
	
	String *hostAddress;
	
	for(int i=0;;i++){
		if(inetAddress[i]!=NULL){
			hostAddress=inetAddress[i]->getHostAddress();
		}else{
			break;
		}
	}
	
	return InetAddress::getByName(hostAddress);
}

