/*   InetAddressManager NX  Ver 0.00   */
/*                                         */
/*                                         */
/*   by toyo    1999/4/29                  */

#include "basic.h"

#include "NetworkException.h"
#include "InetAddress.h"
#include "InetAddressManager.h"

InetAddressManager::InetAddressManager(){
	this->inetAddressByName=NULL;
	this->inetAddressAllByName=NULL;
	this->localHost=NULL;

	this->isGetByName=true;
	this->isGetAllByName=true;
	this->isGetLocalHost=true;
}

InetAddressManager::~InetAddressManager(){
}

boolean InetAddressManager::getByName(String* name,InetAddress* inetAddress) throw (NetworkException*){
	if(!isGetByName){
		return false;
	}else{
		this->isGetByName=false;
		inetAddress=InetAddress::getByName(name);
		this->inetAddressByName=inetAddress;
		return true;
	}
}

boolean InetAddressManager::getAllByName(String* name,InetAddress** inetAddress) throw (NetworkException*){
	if(!isGetAllByName){
		return false;
	}else{
		this->isGetAllByName=false;
		inetAddress=InetAddress::getAllByName(name);
		this->inetAddressAllByName=inetAddress;
		return true;
	}
}

boolean InetAddressManager::getLocalHost(InetAddress* inetAddress) throw (NetworkException*){
	if(!isGetLocalHost){
		return false;
	}else{
		this->isGetLocalHost=false;
		inetAddress=InetAddress::getLocalHost();
		this->localHost=inetAddress;
		return true;
	}
}
	
boolean InetAddressManager::isCompleteGetByName() throw (NetworkException*){
	return isGetByName;
}

boolean InetAddressManager::isCompleteGetAllByName() throw (NetworkException*){
	return isGetAllByName;
}

boolean InetAddressManager::isCompleteGetLocalHost() throw (NetworkException*){
	return isGetLocalHost;
}

void InetAddressManager::cancelGetByName() throw (NetworkException*){
	this->isGetByName=true;
	this->inetAddressByName=NULL;
}

void InetAddressManager::cancelGetAllByName() throw (NetworkException*){
	this->isGetAllByName=true;
	this->inetAddressAllByName=NULL;
}

void InetAddressManager::cancelGetLocalHost() throw (NetworkException*){
	this->isGetLocalHost=true;
	this->localHost=NULL;
}
