/*   TCPInputStream NX  Ver 0.10 */
/*                                   */
/*                                   */
/*   by toyo    1999/4/29            */

#include "basic.h"
#include "../io/IOException.h"
#include "../io/OutputStream.h"
#include "../io/InputStream.h"

#include "WinSockManager.h"
#include "TCPInputStream.h"

#include <stdio.h>

//private constructor

TCPInputStream::TCPInputStream(SOCKET sock,DWORD bufferSize) throw (IOException*){
	this->sock=sock;
	
	this->buffer=new BYTE[bufferSize];
	this->subBuffer=new BYTE[bufferSize];
	this->wsabuf.len=bufferSize;
	this->wsabuf.buf=(char *)buffer;
	this->bufferSize=bufferSize;
	this->subBufferIndex=0;
	this->subBufferRecvd=0;

	this->overlapped.hEvent=WSACreateEvent();
	if(overlapped.hEvent==WSA_INVALID_EVENT){
		throw new IOException(new String("WSA_INVALID_EVENT"));
	}

	this->dwFlags=0;
	this->dwRecvd=0;
	
	receive();
}

TCPInputStream::~TCPInputStream(){
	delete[] buffer;
	delete[] subBuffer;
}

//public member function

int TCPInputStream::read() throw (IOException*){
	int returnValue;
	if(subBufferRecvd-subBufferIndex>0){
		returnValue=subBuffer[subBufferIndex];
		subBufferIndex++;
		if(subBufferIndex==subBufferRecvd)receive();
		return returnValue;
	}else if(isReceived()){
		returnValue=subBuffer[subBufferIndex];
		subBufferIndex++;
		if(subBufferIndex==subBufferRecvd)receive();
		return returnValue;
	}else{
		return -1;
	}
}

int TCPInputStream::read(BYTE string[],int off,int len) throw (IOException*){
	int subBufferUnRead=subBufferRecvd-subBufferIndex;
	
	if(subBufferUnRead>0){
		if(subBufferUnRead>len){
			memmove(string+off,subBuffer+subBufferIndex,len);
			subBufferIndex+=len;
			return len;
		}else if(subBufferUnRead==len){
			memmove(string+off,subBuffer+subBufferIndex,len);
			receive();
			return len;
		}else{
			memmove(string+off,subBuffer+subBufferIndex,subBufferUnRead);
			receive();
			return read(string,off+subBufferUnRead,
					len-subBufferUnRead)+subBufferUnRead;
		}
	}else if(isReceived()){
		return read(string,off,len);
	}else{
		return 0;
	}
}



//private member function

//receive() Ăяoɗ܂f[^ true Ԃ
boolean TCPInputStream::isReceived() throw (IOException*){
	boolean isFinished=WSAGetOverlappedResult(sock,&overlapped,&dwRecvd,FALSE,&dwFlags);
	if(!isFinished){
		if(WSAGetLastError()==WSA_IO_INCOMPLETE){
			return false;
		}else{
			//O𓊂鏈
			throw new IOException(WinSockManager::getErrorMessage(WSAGetLastError()));
			return false;
		}
	}else if(dwRecvd==0){
		return false;
	}else{
		//WSACloseEvent(this->overlapped.hEvent);
		memmove(subBuffer,buffer+subBufferRecvd,dwRecvd);
		subBufferRecvd+=dwRecvd;
//printf("isReceived() dwFlags(%d) dwRecvd(%d) \n",dwFlags,dwRecvd);
		return true;
	}
}

//ĂяoɎ󂯎f[^ true ԂB
boolean TCPInputStream::receive() throw (IOException*){
	dwFlags=0;
	subBufferRecvd=0;
	subBufferIndex=0;
	
	/*
	this->overlapped.hEvent=WSACreateEvent();
	if(overlapped.hEvent==WSA_INVALID_EVENT){
		throw new IOException(new String("WSA_INVALID_EVENT"));
	}
	*/

	int nRet=WSARecv(sock,&wsabuf,1,&dwRecvd,&dwFlags,&overlapped,NULL);
	if(nRet==0){
//printf("receive() %d \n",dwRecvd);
		subBufferRecvd+=dwRecvd;
		memmove(subBuffer,buffer,dwRecvd);
//		WSACloseEvent(this->overlapped.hEvent);
		return true;
	}else if(nRet==SOCKET_ERROR){
		if(WSAGetLastError()==WSA_IO_PENDING){
			return false;
		}else{
			//O𓊂鏈
			throw new IOException(WinSockManager::getErrorMessage(WSAGetLastError()));
			return false;
		}
	}else{
		return false;
	}
}

