/*   WinSockManager NX  Ver 0.01   */
/*                                     */
/*                                     */
/*   by toyo    1999/4/26              */

#include "basic.h"
#include "WinsockManager.h"
#include <stdio.h>

void WinSockManager::initWinSock(void){
  int nRes;
  WSADATA wsaData; 
  WORD wVerRequested = MAKEWORD(2,2);// ver 2.2 
    
  // Init the sockets interface 
  nRes = WSAStartup(wVerRequested, &wsaData); 
  if(nRes){ 
    fprintf(stderr, "Couldn't init winsock: %d\n", nRes); 
  }
}

void WinSockManager::releaseWinSock(void){
	WSACleanup();
}

String* WinSockManager::getErrorMessage(int errorID){
	switch(errorID){
		case WSAEINTR:
			return new String("WSAEINTR");
		case WSAEBADF:
			return new String("WSAEBADF");
		case WSAEACCES:
			return new String("WSAEACCES");
		case WSAEFAULT:
			return new String("WSAEFAULT");
		case WSAEINVAL:
			return new String("WSAEINVAL");
		case WSAEMFILE:
			return new String("WSAEMFILE");
		case WSAEWOULDBLOCK:
			return new String("WSAEWOULDBLOCK");
		case WSAEINPROGRESS:
			return new String("WSAEINPROGRESS");
		case WSAEALREADY:
			return new String("WSAEALREADY");
		case WSAENOTSOCK:
			return new String("WSAENOTSOCK");
		case WSAEDESTADDRREQ:
			return new String("WSAEDESTADDRREQ");
		case WSAEMSGSIZE:
			return new String("WSAEMSGSIZE");
		case WSAEPROTOTYPE:
			return new String("WSAEPROTOTYPE");
		case WSAENOPROTOOPT:
			return new String("WSAENOPROTOOPT");
		case WSAEPROTONOSUPPORT:
			return new String("WSAEPROTONOSUPPORT");
		case WSAESOCKTNOSUPPORT:
			return new String("WSAESOCKTNOSUPPORT");
		case WSAEOPNOTSUPP:
			return new String("WSAEOPNOTSUPP");
		case WSAEPFNOSUPPORT:
			return new String("WSAEPFNOSUPPORT");
		case WSAEAFNOSUPPORT:
			return new String("WSAEAFNOSUPPORT");
		case WSAEADDRINUSE:
			return new String("WSAEADDRINUSE");
		case WSAEADDRNOTAVAIL:
			return new String("WSAEADDRNOTAVAIL");
		case WSAENETDOWN:
			return new String("WSAENETDOWN");
		case WSAENETUNREACH:
			return new String("WSAENETUNREACH");
		case WSAENETRESET:
			return new String("WSAENETRESET");
		case WSAECONNABORTED:
			return new String("WSACONNABORTED");
		case WSAECONNRESET:
			return new String("WSAECONNRESET");
		case WSAENOBUFS:
			return new String("WSAENOBUFS");
		case WSAEISCONN:
			return new String("WSAEISCONN");
		case WSAENOTCONN:
			return new String("WSAENOTCONN");
		case WSAESHUTDOWN:
			return new String("WSAESHUTDOWN");
		case WSAETOOMANYREFS:
			return new String("WSAETOOMANYREFS");
		case WSAETIMEDOUT:
			return new String("WSAETIMEDOUT");
		case WSAECONNREFUSED:
			return new String("WSAECONNREFUSED");
		case WSAELOOP:
			return new String("WSAELOOP");
		case WSAENAMETOOLONG:
			return new String("WSAENAMETOOLONG");
		case WSAEHOSTDOWN:
			return new String("WSAEHOSTDOWN");
		case WSAEHOSTUNREACH:
			return new String("WSAEHOSTUNREACH");
		case WSAENOTEMPTY:
			return new String("WSAENOTEMPTY");
		case WSAEPROCLIM:
			return new String("WSAEPROCLIM");
		case WSAEUSERS:
			return new String("WSAEUSERS");
		case WSAEDQUOT:
			return new String("WSAEDQUOT");
		case WSAESTALE:
			return new String("WSAESTALE");
		case WSAEREMOTE:
			return new String("WSAEREMOTE");
		case WSASYSNOTREADY:
			return new String("WSASYSNOTREADY");
		case WSAVERNOTSUPPORTED:
			return new String("WSAVERNOTSUPPORTED");
		case WSANOTINITIALISED:
			return new String("WSANOTINITIALIZED");
		case WSAEDISCON:
			return new String("WSAEDISCON");
		case WSAENOMORE:
			return new String("WSAENOMORE");
		case WSAECANCELLED:
			return new String("WSAECANCELLED");
		case WSAEINVALIDPROCTABLE:
			return new String("WSAEINVALIDPROCTABLE");
		case WSAEINVALIDPROVIDER:
			return new String("WSAEINVALIDPROVIDER");
		case WSAEPROVIDERFAILEDINIT:
			return new String("WSAEPROVIDERFAILEDINIT");
		case WSASYSCALLFAILURE:
			return new String("WSASYSCALLFAILURE");
		case WSASERVICE_NOT_FOUND:
			return new String("WSASERVICE_NOT_FOUND");
		case WSATYPE_NOT_FOUND:
			return new String("WSATYPE_NOT_FOUND");
		case WSA_E_NO_MORE:
			return new String("WSA_E_NO_MORE");
		case WSA_E_CANCELLED:
			return new String("WSA_E_CANCELLED");
		case WSAEREFUSED:
			return new String("WSAEREFUSED");
		case WSAHOST_NOT_FOUND:
			return new String("WSAHOST_NOT_FOUND");
		case WSATRY_AGAIN:
			return new String("WSATRY_AGAIN");
		case WSANO_RECOVERY:
			return new String("WSANO_RECOVERY");
		case WSANO_DATA:
			return new String("WSANO_DATA");
		default:
			return new String("UNKNOWN_WINSOCK_ERROR");
	}
}
