/*   DirectSoundManager NX   Ver 0.00 */
/*                                        */
/*                                        */
/*   by Toyonori    1999/4/4             */

class WaveFormat;
class StreamSoundPlayer;
class SoundRecorder;
class SoundBuffer;
class SoundData;
class SoundData3D;
class SoundListener3D;
class WaveformAudioRecorder;

class DirectSoundManager:public Object{
private:
	LPDIRECTSOUND lpDirectSound;
	DSCAPS dsCaps;
	
	LPDIRECTSOUNDCAPTURE lpDirectSoundCapture;
	DSCCAPS dsCaptureCaps;
	
	IDirectMusic *lpDirectMusic;
	
	HWAVEIN hWaveIn;
	
	static boolean CALLBACK DSEnumProc(
		LPGUID lpGUID,LPCTSTR lpszDesc,
		LPCTSTR lpszDrvName,LPVOID lpContext
	);
	
	static boolean CALLBACK DSCaptureEnumProc(
		LPGUID lpGUID,LPCTSTR lpszDesc,
		LPCTSTR lpszDrvName,LPVOID lpContext
	);

	//if(a>=b)true
	//else false
	static boolean compareDSCAPS(DSCAPS a,DSCAPS b);
	static DWORD evaluateDSCAPS(DSCAPS caps);

	static DWORD evaluateDSCaptureCAPS(DSCCAPS caps);
public:
	DirectSoundManager(void);
	~DirectSoundManager(void);
	
	virtual boolean initDirectSound(HWND hWnd);
	virtual boolean initDirectSoundCapture(void);
	virtual boolean initDirectMusic(HWND hWnd);
	virtual boolean releaseDirectSound(void);
	virtual boolean releaseDirectSoundCapture(void);
	
	virtual SoundRecorder* getDirectSoundRecorder(
		WaveFormat *waveFormat,
		SoundBuffer *soundBuffer
	);
	
	virtual boolean initWaveformAudioRecorder(
		WaveFormat *waveFormat
	);
	
	virtual SoundRecorder* getWaveformAudioRecorder(
		SoundBuffer *soundBuffer
	);
	
	virtual SoundRecorder* getWaveformAudioRecorder(
		SoundBuffer *soundBuffer,
		DWORD dwCompressionRate
	);

	virtual StreamSoundPlayer* getStreamSoundPlayer(
		WaveFormat *waveFormat,
		SoundBuffer *soundBuffer
	);
	
	virtual StreamSoundPlayer* getStreamSoundPlayer(
		WaveFormat *waveFormat,
		DWORD dwUncompressionRate,
		SoundBuffer *soundBuffer
	);
	
	virtual LPDIRECTSOUNDBUFFER getDirectSoundBuffer(DWORD dwFlags);
	
	virtual LPDIRECTSOUNDBUFFER getDirectSoundBuffer(
		SoundData *soundData
	);
	
	virtual LPDIRECTSOUND3DBUFFER getDirectSound3DBuffer(
		SoundData3D *soundData3D
	);
	
	virtual LPDIRECTSOUND3DBUFFER getDirectSound3DBuffer(
		SoundData3D *soundData3D,
		DWORD dwFlags
	);
	
	virtual SoundListener3D *getSoundListener3D(void);

	virtual LPDIRECTSOUND getDirectSound(void);
	virtual DSCAPS getDirectSoundCaps(void);
	virtual LPDIRECTSOUNDCAPTURE getDirectSoundCapture(void);
	virtual DSCCAPS getDirectSoundCaptureCaps(void);
	virtual IDirectMusic* getDirectMusic(void);
};
