/* DirectSoundRecorder NX  Ver 0.00  */
/*                                       */
/*                                       */
/*   by toyo        1999/4/8             */

#include "basic.h"

#include "lib/io/InputStream.h"
#include "lib/io/OutputStream.h"
#include "lib/io/ObjectInputStream.h"
#include "lib/io/ObjectOutputStream.h"
#include "lib/io/Serializable.h"

#include "WaveFormat.h"
#include "SoundBuffer.h"
#include "SoundRecorder.h"
#include "DirectSoundRecorder.h"

DirectSoundRecorder::DirectSoundRecorder(
	LPDIRECTSOUNDCAPTUREBUFFER lpDirectSoundCaptureBuffer,
	SoundBuffer *soundBuffer
	){
	this->lpDirectSoundCaptureBuffer=lpDirectSoundCaptureBuffer;
	this->soundBuffer=soundBuffer;
	this->dwPastReadCursor=soundBuffer->getBufferSize()-soundBuffer->getBlockSize();
}
	
DirectSoundRecorder::~DirectSoundRecorder(){
	lpDirectSoundCaptureBuffer->Release();
}

boolean DirectSoundRecorder::start(){
	HRESULT hr=lpDirectSoundCaptureBuffer->Start(DSCBSTART_LOOPING);
	if(hr!=DS_OK){
		Debugger::printErrorDSound(hr);
		return false;
	}else{
		return true;
	}
}

boolean DirectSoundRecorder::processRecording(){
	HRESULT hr;
	
	DWORD dwCapturePosition;
	DWORD dwReadPosition;

	hr=lpDirectSoundCaptureBuffer->GetCurrentPosition(
		&dwCapturePosition,&dwReadPosition
	);
	if(hr!=DS_OK){
		Debugger::printErrorDSound(hr);
		return false;
	}
	
	DWORD dwReadCursor;
	dwReadCursor=(this->dwPastReadCursor+soundBuffer->getBlockSize())%soundBuffer->getBufferSize();
	
	if(dwCapturePosition-dwReadCursor > 0 && 
		dwCapturePosition-dwReadCursor < soundBuffer->getBlockSize()){
		return false;
	}else{
		this->dwPastReadCursor=dwReadCursor;
	}
	
	LPVOID lpvPtr1; 
    DWORD dwBytes1; 
    LPVOID lpvPtr2;
    DWORD dwBytes2; 
		
	hr=lpDirectSoundCaptureBuffer->Lock(
		dwReadCursor,
		soundBuffer->getBlockSize(),
		&lpvPtr1,
		&dwBytes1,
		&lpvPtr2, 
		&dwBytes2, 
		0
	);
	
	if(hr!=DS_OK){
		Debugger::printErrorDSound(hr);
		return false;
	}
			
	memmove(soundBuffer->getBlock(currentBlockNo),lpvPtr1,dwBytes1);
	if(lpvPtr2!=NULL){
		memmove(soundBuffer->getBlock(currentBlockNo)+dwBytes1,lpvPtr2,dwBytes2);
	}
	currentBlockNo=(currentBlockNo+1)%soundBuffer->getBlockNum();
	
	hr=lpDirectSoundCaptureBuffer->Unlock(
		lpvPtr1,
		dwBytes1, 
		lpvPtr2, 
		dwBytes2 
	);

	if(hr!=DS_OK){
		Debugger::printErrorDSound(hr);
		return false;
	}
	
	return true;
}

boolean DirectSoundRecorder::stop(){
	HRESULT hr;
	hr=lpDirectSoundCaptureBuffer->Stop();
	if(hr!=DS_OK){
		Debugger::printErrorDSound(hr);
		return false;
	}else{
		return true;
	}
}
	
int DirectSoundRecorder::getPastBlockNo(){
	return (soundBuffer->getBlockNum()+currentBlockNo-1)%soundBuffer->getBlockNum();
}

int DirectSoundRecorder::getCurrentBlockNo(){
	return currentBlockNo;
}
