/* SoundBuffer NX  Ver 0.00   */
/*                                */
/*                                */
/*   by toyo    1999/4/8          */

#include "basic.h"

#include "lib/io/InputStream.h"
#include "lib/io/OutputStream.h"
#include "lib/io/ObjectInputStream.h"
#include "lib/io/ObjectOutputStream.h"
#include "lib/io/Serializable.h"
#include "SoundBuffer.h"

SoundBuffer::SoundBuffer(void){
	this->buffer=NULL;
}

SoundBuffer* SoundBuffer::newInstance(int id){
	return new SoundBuffer();
}

//32768=1024 x 32
SoundBuffer::SoundBuffer(int blockSize=32768,int blockNum=4){
	this->blockSize=blockSize;
	this->blockNum=blockNum;
	this->bufferSize=blockSize*blockNum;
	
	this->buffer=new char[bufferSize];
}

SoundBuffer::SoundBuffer(char *buffer,int blockSize,int blockNum){
	this->buffer=buffer;
	this->blockSize=blockSize;
	this->blockNum=blockNum;
	
	this->bufferSize=blockSize*blockNum;
}

SoundBuffer::~SoundBuffer(){
	if(buffer!=NULL)
		delete[] buffer;
}
 
SoundBuffer* SoundBuffer::clone(){
	SoundBuffer *soundBuffer=new SoundBuffer(blockSize,blockNum);
	memmove(soundBuffer->getBuffer(),this->buffer,this->bufferSize);
	return soundBuffer;
}

char* SoundBuffer::getBuffer(){
	return buffer;
}

char* SoundBuffer::getBlock(int blockNo){
	if(blockNo<blockNum){
		return buffer+blockNo*blockSize;
	}else{
		return NULL;
	}
}

void SoundBuffer::setBuffer(char *buffer){
	this->buffer=buffer;
}

void SoundBuffer::setBlockNum(int blockNum){
	this->blockNum=blockNum;
}

void SoundBuffer::setBlockSize(int blockSize){
	this->blockSize=blockSize;
}

void SoundBuffer::setBufferSize(int bufferSize){
	this->bufferSize=bufferSize;
}

int SoundBuffer::getBlockNum(){
	return blockNum;
}

int SoundBuffer::getBlockSize(){
	return blockSize;
}

int SoundBuffer::getBufferSize(){
	return bufferSize;
}



int SoundBuffer::getTypeID(void){
	return 0;
}

void SoundBuffer::readObject(ObjectInputStream* in){
	this->blockSize=in->readInteger();
	this->blockNum=in->readInteger();
	this->bufferSize=blockSize*blockNum;
	
	this->buffer=new char[bufferSize];
	
	for(int i=0;i<bufferSize;i++){
		this->buffer[i]=in->readByte();
	}
}

void SoundBuffer::writeObject(ObjectOutputStream* out){
	out->writeInteger(blockSize);
	out->writeInteger(blockNum);
	
	for(int i=0;i<blockSize*blockNum;i++){
		out->writeByte(buffer[i]);
	}
}
