/* SoundData NX	 Ver 0.00	   */
/*					       		  */
/*								  */
/*	 by toyo		1999/5/2      */

#include "basic.h"

#include "lib/io/InputStream.h"
#include "lib/io/OutputStream.h"
#include "lib/io/ObjectInputStream.h"
#include "lib/io/ObjectOutputStream.h"
#include "lib/io/Serializable.h"

#include "SoundBuffer.h"
#include "WaveFormat.h"
#include "SoundData.h"

SoundData::SoundData(void){
	this->soundBuffer=NULL;
	this->waveFormat=NULL;
	this->lpDirectSoundBuffer=NULL;
	this->isStaticSound=true;
	this->firstPlay=true;
	this->duplicateSoundNum=1;
	this->lpDirectSoundBufferArray=NULL;
}

SoundData::SoundData(SoundBuffer *soundBuffer,WaveFormat *waveFormat){
	this->soundBuffer=soundBuffer;
	this->waveFormat=waveFormat;
	this->isStaticSound=true;
	this->firstPlay=true;
	this->duplicateSoundNum=1;
	this->lpDirectSoundBufferArray=NULL;
}

SoundData::SoundData(SoundBuffer *soundBuffer,WaveFormat *waveFormat,int duplicateSoundNum){
	this->soundBuffer=soundBuffer;
	this->waveFormat=waveFormat;
	this->isStaticSound=true;
	this->firstPlay=true;
	this->duplicateSoundNum=duplicateSoundNum;
	if(duplicateSoundNum>1)
		this->lpDirectSoundBufferArray=new LPDIRECTSOUNDBUFFER[duplicateSoundNum-1];
}

SoundData::~SoundData(void){
	delete waveFormat;
	delete soundBuffer;
	if(lpDirectSoundBuffer!=NULL){
		lpDirectSoundBuffer->Release();
	}
}

SoundData* SoundData::clone(void){
	return new SoundData(soundBuffer->clone(),waveFormat->clone());
}

SoundBuffer* SoundData::getSoundBuffer(void){
	return soundBuffer;
}

boolean SoundData::isStatic(void){
	return isStaticSound;
}

void SoundData::setStatic(boolean isStaticSound){
	this->isStaticSound=isStaticSound;
}

boolean SoundData::isFirstPlay(void){
	return firstPlay;
}

void SoundData::setFirstPlay(boolean firstPlay){
	this->firstPlay=firstPlay;
}

WaveFormat* SoundData::getWaveFormat(void){
	return waveFormat;
}

LPDIRECTSOUNDBUFFER SoundData::getDirectSoundBuffer(void){
	return lpDirectSoundBuffer;
}

LPDIRECTSOUNDBUFFER SoundData::getDirectSoundBuffer(int index){
	if(index==0){
		return lpDirectSoundBuffer;
	}else if(this->lpDirectSoundBufferArray!=NULL && index>0 && index<duplicateSoundNum){
		return lpDirectSoundBufferArray[index-1];
	}else{
		return NULL;
	}
}

void SoundData::setDirectSoundBuffer(LPDIRECTSOUNDBUFFER lpDirectSoundBuffer,int index){
	if(index==0){
		this->lpDirectSoundBuffer=lpDirectSoundBuffer;
	}else if(this->lpDirectSoundBufferArray!=NULL && index>0 && index<duplicateSoundNum){
		this->lpDirectSoundBufferArray[index-1]=lpDirectSoundBuffer;
	}
}

int SoundData::getDuplicateSoundNum(void){
	return this->duplicateSoundNum;
}

SoundData* SoundData::newInstance(int id){
	return new SoundData();
}

int SoundData::getTypeID(void){
	return 0;
}

void SoundData::readObject(ObjectInputStream* in){
	waveFormat=::readObject<WaveFormat>(in);
	soundBuffer=::readObject<SoundBuffer>(in);
}

void SoundData::writeObject(ObjectOutputStream* out){
	::writeObject<WaveFormat>(out,waveFormat);
	::writeObject<SoundBuffer>(out,soundBuffer);
}
