/*	 SoundListener3D NX		Ver 0.00 */
/*										 */
/*			    						 */
/*	 by toyo		1999/5/16			*/

#include "basic.h"

#include "lib/io/InputStream.h"
#include "lib/io/OutputStream.h"
#include "lib/io/ObjectInputStream.h"
#include "lib/io/ObjectOutputStream.h"
#include "lib/io/Serializable.h"

#include "lib/math/Vector3.h"
#include "SoundListener3D.h"

/*
SoundListener3D::SoundListener3D(DS3DLISTENER desc3DListener){
	this->desc3DListener=desc3DListener;
}
*/

SoundListener3D::SoundListener3D(void){
}

SoundListener3D::~SoundListener3D(void){
}

/*
DS3DLISTENER SoundListener3D::getDS3DLISTENER(void){
	return this->desc3DListener;
}
*/

LPDIRECTSOUNDBUFFER SoundListener3D::getDirectSoundBuffer(void){
	return this->lpDirectSoundBuffer;
}

LPDIRECTSOUND3DLISTENER SoundListener3D::getDirectSound3DListener(void){
	return this->lpDirectSound3DListener;
}

void SoundListener3D::setDistanceFactor(D3DVALUE flDistanceFactor){
	HRESULT hr;
	//this->desc3DListener.flDistanceFactor=flDistanceFactor;
	//this->lpDirectSound3DListener->SetDistanceFactor(flDistanceFactor);
	hr=this->lpDirectSound3DListener->SetDistanceFactor(flDistanceFactor,DS3D_DEFERRED);
	//this->lpDirectSound3DListener->SetDistanceFactor(flDistanceFactor,DS3D_DEFERRED); 
	if(hr!=DS_OK){
		Debugger::println("SoundListener3D::setDistanceFactor()");
		Debugger::printErrorDSound(hr);
	}
}

void SoundListener3D::setDopplerFactor(D3DVALUE flDopplerFactor){
	HRESULT hr;
	//this->desc3DListener.flDopplerFactor=flDopplerFactor;
	//this->lpDirectSound3DListener->SetDopplerFactor(flDopplerFactor);
	hr=this->lpDirectSound3DListener->SetDopplerFactor(flDopplerFactor,DS3D_DEFERRED);
	//this->lpDirectSound3DListener->SetDopplerFactor(flDopplerFactor,DS3D_DEFERRED);
	if(hr!=DS_OK){
		Debugger::println("SoundListener3D::setDopplerFactor()");
		Debugger::printErrorDSound(hr);
	}
}

void SoundListener3D::setOrientation(Vector3 *front,Vector3 *top){
	HRESULT hr;
	//this->desc3DListener.vOrientFront=front->getVector();
	//this->desc3DListener.vOrientTop=top->getVector();
	/*
	this->lpDirectSound3DListener->SetOrientation(
		front->getX(),front->getY(),front->getZ(),
		top->getX(),top->getX(),top->getZ()
	);
	*/
	
	/*
	Debugger::println(front->getX());
	Debugger::println(front->getY());
	Debugger::println(front->getZ());
	Debugger::println(top->getX());
	Debugger::println(top->getY());
	Debugger::println(top->getZ());
	*/
	
	hr=this->lpDirectSound3DListener->SetOrientation(
		front->getX(),front->getY(),front->getZ(),
		top->getX(),top->getX(),top->getZ(),
		DS3D_DEFERRED
	);

	/*
	this->lpDirectSound3DListener->SetOrientation(
		front->getX(),front->getY(),front->getZ(),
		top->getX(),top->getX(),top->getZ(),
		DS3D_DEFERRED
	);
	*/

	if(hr!=DS_OK){
		//Debugger::println("SoundListener3D::setOrientation()");
		//Debugger::printErrorDSound(hr);
	}
}

void SoundListener3D::setPosition(Vector3 *position){
	HRESULT hr;
	//this->desc3DListener.vPosition=position->getVector();
	/*
	this->lpDirectSound3DListener->SetPosition(
		position->getX(),position->getY(),position->getZ()
	);
	*/
	
	hr=this->lpDirectSound3DListener->SetPosition(
		position->getX(),position->getY(),position->getZ(),
		DS3D_DEFERRED
	);
	
	/*
	this->lpDirectSound3DListener->SetPosition(
		position->getX(),position->getY(),position->getZ(),
		DS3D_DEFERRED
	);
	*/
	if(hr!=DS_OK){
		Debugger::println("SoundListener3D::setPosition()");
		Debugger::printErrorDSound(hr);
	}
}

void SoundListener3D::setRolloffFactor(D3DVALUE flRolloffFactor){
	HRESULT hr;
	//this->desc3DListener.flRolloffFactor=flRolloffFactor;
	//this->lpDirectSound3DListener->SetRolloffFactor(flRolloffFactor);
	hr=this->lpDirectSound3DListener->SetRolloffFactor(flRolloffFactor,DS3D_DEFERRED);
	//this->lpDirectSound3DListener->SetRolloffFactor(flRolloffFactor,DS3D_DEFERRED);
	if(hr!=DS_OK){
		Debugger::println("SoundListener3D::setRolloffFactor()");
		Debugger::printErrorDSound(hr);
	}
}

void SoundListener3D::setVelocity(Vector3 *velocity){
	HRESULT hr;
	//this->desc3DListener.vVelocity=velocity->getVector();
	/*
	this->lpDirectSound3DListener->SetVelocity(
		velocity->getX(),velocity->getY(),velocity->getZ()
	);
	*/

	hr=this->lpDirectSound3DListener->SetVelocity(
		velocity->getX(),velocity->getY(),velocity->getZ(),
		DS3D_DEFERRED
	);
	
	/*
	this->lpDirectSound3DListener->SetVelocity(
		velocity->getX(),velocity->getY(),velocity->getZ(),
		DS3D_DEFERRED
	);
	*/

	if(hr!=DS_OK){
		Debugger::println("SoundListener3D::setVelocity()");
		Debugger::printErrorDSound(hr);
	}
}

void SoundListener3D::commitDeferredSettings(void){
	HRESULT hr=this->lpDirectSound3DListener->CommitDeferredSettings();
	if(hr!=DS_OK){
		Debugger::println("SoundListener3D::commitDeferredSettings(void):");
		Debugger::printErrorDSound(hr);
	}
}

void SoundListener3D::setVolume(long volume){
	lpDirectSoundBuffer->SetVolume(volume);
}

long SoundListener3D::getVolume(void){
	long volume;
	lpDirectSoundBuffer->GetVolume(&volume);
	return volume;
}

/*
void SoundListener3D::setToDirectSound3DListener(void){
	Debugger::println("listener x=");
	Debugger::println(desc3DListener.vPosition.x);
	
	//this->setToDirectSound3DListener(DS3D_DEFERRED);
}

void SoundListener3D::setToDirectSound3DListener(DWORD dwApply){
	HRESULT hr=lpDirectSound3DListener->SetAllParameters(&desc3DListener,dwApply);
	if(hr!=DS_OK){
		Debugger::printErrorDSound(hr);
		Debugger::println("SoundListener3D::setToDirectSound3DListener(DWORD dwApply)");
	}
}
*/