/*   nbV\          Ver 0.20   */
/*                                  */
/*                                  */
/*   by Atsushi          1999/9/8   */
/*   by Y.Hayashi       1999/6/27   */


template <class Type> class HashtableEnumeration;


template <class KeyType,class ValueType> class Hashtable:public Object
{
private:
	class Element:public Object
	{
	public:
		int hash;
		KeyType* key;
		ValueType* value;
		Element *next;
	};
	
	Element** table;
	int length;
	int count; 
	int threshhold;
	float loadFactor;

public:
	Hashtable(int initialCapacity,float loadFactor);
	Hashtable(int initialCapacity);
	Hashtable(void);
	~Hashtable(void);
	
	void init(int initialCapacity,float loadFactor);
	void initArray(void);
	
	virtual void clear(void);
	virtual void deleteAll(void);
	
	virtual ValueType* get(KeyType* key);
	virtual ValueType* put(KeyType* key,ValueType* value);
	
	virtual boolean containsKey(KeyType* key);
//	virtual boolean containsValue(ValueType* value);
	
	virtual int getSize(void);
	virtual boolean isEmpty(void);
	
	virtual HashtableEnumeration<KeyType>* getKeys(void);
	virtual HashtableEnumeration<ValueType>* getElements(void);
};


#include "Hashtable.cpp"
