/*   vpeB[  Ver 0.30   */
/*                            */
/*                            */
/*   by Atsushi  1999/11/23   */


#include "basic.h"

#include <mbstring.h>

#include "Vector.h"
#include "Enumeration.h"
#include "HashtableEnumeration.h"
#include "Hashtable.h"
#include "lib/io/InputStream.h"
#include "lib/io/IOException.h"
#include "StringBuffer.h"
#include "Properties.h"


/*   ---   RXgN^   ---   */

Properties::Properties(void)
{
	table=new Hashtable<String,String>();
}


/*   ---   ǂ݂   ---   */

void Properties::load(InputStream* in)
{
	StringBuffer* buffer;
	String* key;
	String* value;
	int ch;

	try {
		while (TRUE)
		{
			ch=in->read();
			
			if (ch==-1)
			{
				in->close();
				return;
			}
			else if (ch=='#')
			{
				do {
					ch=in->read();
				} while (ch!=-1 && (_ismbblead(ch) || (ch!='\n' && ch!='\r')));
			}
			else if (ch=='\n' || ch=='\r')
			{
				continue;
			}
			else
			{
				buffer=new StringBuffer();
				do {
					buffer->append((char)(ch));
					ch=in->read();
				} while (ch!=-1 && (_ismbblead(ch) || ch!='='));
				key=buffer->toString();
				delete buffer;
				
				if (ch==-1)
				{
					delete key;
					continue;
				}
				
				ch=in->read();
				
				buffer=new StringBuffer();
				do {
					buffer->append((char)(ch));
					ch=in->read();
				} while (ch!=-1 && (_ismbblead(ch) || (ch!='\n' && ch!='\r')));
				value=buffer->toString();
				delete buffer;
				
				table->put(key->trim(),value->trim());
				delete key;
				delete value;
			}
		}
	}
	catch (IOException* e)
	{
		throw e;
	}
}


/*   ---   vpeB[   ---   */

String* Properties::getProperty(String* key)
{
	return getProperty(key,NULL);
}

String* Properties::getProperty(String* key,String* dafaultValue)
{
	if (table->containsKey(key))
	{
		return table->get(key);
	}
	else
	{
		return dafaultValue;
	}
}


/*   ---   vpeB[ ()   ---   */

String* Properties::getStringProperty(String* key)
{
	return getStringProperty(key,NULL);
}

String* Properties::getStringProperty(String* key,String* dafaultValue)
{
	String* property;

	property=getProperty(key);
	
	return (property==NULL ? dafaultValue : new String(property));
}


/*   ---   vpeB[ ()   ---   */

int Properties::getIntegerProperty(String* key)
{
	return getIntegerProperty(key,0);
}

int Properties::getIntegerProperty(String* key,int dafaultValue)
{
	String* property;

	property=getProperty(key);
	
	return (property==NULL ? dafaultValue : property->toInteger());
}


/*   ---   vpeB[ ()   ---   */

double Properties::getDoubleProperty(String* key)
{
	return getDoubleProperty(key,0.0);
}

double Properties::getDoubleProperty(String* key,double dafaultValue)
{
	String* property;

	property=getProperty(key);
	
	return (property==NULL ? dafaultValue : property->toDouble());
}


/*   ---   vpeB[ (u[A)   ---   */

boolean Properties::getBooleanProperty(String* key)
{
	return getBooleanProperty(key,FALSE);
}

boolean Properties::getBooleanProperty(String* key,boolean dafaultValue)
{
	String* property;

	property=getProperty(key);
	
	if (property==NULL) return dafaultValue;
	
	if (property->equalsIgnoreCase("yes"  ) ||
	    property->equalsIgnoreCase("true" ) ||
	    property->equalsIgnoreCase("on"   ) ||
	    property->equalsIgnoreCase("valid"))
	{
		return TRUE;
	}
	else if (property->equalsIgnoreCase("no"     ) ||
	         property->equalsIgnoreCase("false"  ) ||
	         property->equalsIgnoreCase("off"    ) ||
	         property->equalsIgnoreCase("invalid"))
	{
		return FALSE;
	}
	
	return dafaultValue;
}


/*   ---   fXgN^   ---   */

Properties::~Properties(void)
{
	delete table;
}
